;; ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Z80 Abersoft fig-FORTH recompiled
;; Copyright (C) 2024 Ketmar Dark // Invisible Vector
;; Understanding is not required. Only obedience.
;; GPLv3 ONLY
;; ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; ITC interpreted and DO-XXX
;; directly included from "zx-10-startup.f"
;; ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;


;; ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; address interpreter

i-next-push-de-hl:
  push  de
i-next-push-hl:
  push  hl
i-next:
  ld    a, (bc)
  inc   bc
  ld    l, a
  ld    a, (bc)
  inc   bc
  ld    h, a
i-next-cfa-hl:
  ld    e, (hl)
  inc   hl
  ld    d, (hl)
  ex    de, hl
  jp    hl


;; ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; CFA doers

do-colon:
$here zx-do-colon^:!
  ld    hl, () zx-rp
  dec   hl
  ld    (hl), b
  dec   hl
  ld    (hl), c
  ld    zx-rp (), hl
  inc   de
  ld    bc, de
  next

do-quan:
$here zx-do-quan^:!
  inc   de
  ex    de, hl
  ld    e, (hl)
  inc   hl
  ld    d, (hl)
  push  de
  next

do-vect:
$here zx-do-vect^:!
  inc   de
  ex    de, hl
  ld    a, (hl)
  inc   hl
  ld    h, (hl)
  ld    l, a
  jp    # i-next-cfa-hl

do-quan-addr:
$here zx-do-quan-addr^:!
  ld    hl, # -3
  add   hl, de
  jp    # i-next-push-hl

do-quan-to:
$here zx-do-quan-to^:!
  ld    hl, # -5
  add   hl, de
  pop   de
  jp    # zx-word-store-finish

do-quan-add-to:
$here zx-do-quan-add-to^:!
  ld    hl, # -7
  add   hl, de
  pop   de
  jp    # zx-word-add-store-finish

do-constant:
$here zx-do-constant^:!
  inc   de
  ex    de, hl
  ld    e, (hl)
  inc   hl
  ld    d, (hl)
zx-do-constant-finish:
  push  de
  next

do-2constant:
$here zx-do-2constant^:!
  inc   de
  ex    de, hl
  inc   hl
  inc   hl
  ld    e, (hl)
  inc   hl
  ld    d, (hl)
  push  de
  dec   hl
  dec   hl
  ld    d, (hl)
  dec   hl
  ld    e, (hl)
  jr    # zx-do-constant-finish

do-variable:
$here zx-do-variable^:!
$here zx-do-2variable^:!
  inc   de
  push  de
  next

do-uservar:
$here zx-do-uservar^:!
  inc   de
  ex    de, hl
  ld    e, (hl)
  ld    d, # 0
  ld    hl, () zx-uv
  add   hl, de
  jp    # i-next-push-hl

do-does:
$here zx-do-does^:!
  ld    hl, () zx-rp
  dec   hl
  ld    (hl), b
  dec   hl
  ld    (hl), c
  ld    zx-rp (), hl
  inc   de
  ex    de, hl
  ld    c, (hl)
  inc   hl
  ld    b, (hl)
  inc   hl
  jp    # i-next-push-hl

do-vocab:
$here zx-do-vocab^:!
  OPT-NEW-ART-HEADER? [IF]
    ld    hl, de
    inc   hl
  [ELSE]
    ld    hl, # 5
    add   hl, de
  [ENDIF]
  ld    zx-var-context (), hl
  next

do-alias:
$here zx-do-alias^:!
  inc   de
  ex    de, hl
  ld    e, (hl)
  inc   hl
  ld    d, (hl)
  ex    de, hl
  jp    # i-next-cfa-hl


;; ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; special floating point CFAs
OPT-ENABLE-FP? [IF]
do-fp:
$here zx-do-fp^:!
  ;; get pfa
  inc   de
  ex    de, hl
  push  bc
  ld    b, (hl)
do-fp-rst:
  rst   # $28
flush!
  $3B db, ;; fp-calc-2
  $38 db, ;; end-calc
flush!
do-fp-done:
  pop   bc
  next

do-fp-xmem:
$here zx-do-fp-xmem^:!
  ;; get pfa
  \ inc   de
  \ ex    de, hl
  \ pop   de      ;; memidx
  \ push  bc
  \ ld    a, (hl)
  \ add   a, e
  \ ld    b, a
  \ jr    # do-fp-rst
  inc   de        ;; to PFA
  ld    a, (de)   ;; base opcode
  pop   hl        ;; reg#
  add   a, l
  push  bc
  ld    b, a
  jr    # do-fp-rst
[ENDIF]
