;; ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Z80 Abersoft fig-FORTH recompiled
;; Copyright (C) 2024 Ketmar Dark // Invisible Vector
;; Understanding is not required. Only obedience.
;; GPLv3 ONLY
;; ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; initial code: startup, variables, etc.
;; ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;


extend-module TCOM

zx-base-addr zxa:org!
zx-base-addr zxa:ent!
\ zx-base-addr zxa:clr!
$5F00 zxa:clr!

<asm>
cold-entry:
  nop
  jp  # zx-word-cold

warm-entry:
  nop
  jp  # zx-word-warm
flush!

;; non-user global system variables
$here zx-dp^:!
zx-var-dp: 0 dw,

$here zx-fence^:!
zx-var-fence: 0 dw,

$here zx-voclink^:!
zx-var-voclink: 0 dw,

$here zx-current^:!
zx-var-current: 0 dw,

$here zx-context^:!
zx-var-context: 0 dw,

$here zx-state^:!
zx-var-state: 0 dw,

;; in "i-next" (actually, in "do-colon")
zx-rp: 0 dw,

zx-uv: 0 dw,


;; ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; initial DP, FENCE, VOCLINK, FORTH-LATEST
;; WARNING! keep in sync with the order above!

$here zx-dpx-init^:!
0 dw,   ;; DP
0 dw,   ;; FENCE
0 dw,   ;; VOC-LINK
0 dw,   ;; FORTH-LATEST
0 dw,   ;; EDITOR-LATEST


;; ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; initial uservars, used in COLD
;; WARNING! keep in sync with uservar order in "zx-20-prims.f"!

zx-cold-uvars:
$here zx-cold-uvars^:!
zx-s0 dw,   ;; (S0)
zx-r0 dw,   ;; (R0)
\ 0 uservar FLD -- not used in FIG
10    dw,   ;; BASE
 0    dw,   ;; BLK
 0    dw,   ;; DPL
 0    dw,   ;; HLD
 0    dw,   ;; IN
zx-query-tib dw,  ;; TIB
 0    dw,   ;; TSK
zx-cold-uvars-end:
$here zx-cold-uvars^ - zx-cold-#uvars:!

zx-uservars-origin:
$here zx-uvars-origin^:!
$here dup zx-uservar-start^:! zx-uservar-curr^:!
<end-asm>


;; ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; allocate uservars

zx-fix-dp
24 zx-allot0
zx-fix-org
z80asm:emit:here zx-uservar-end^:!


<asm>
;; ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; masks for 42-column print driver

OPT-42-COLS? [IF]
Draw6NormMaskTable:
  ( $FF03 dw,)
  $FFFF dw, ( no mask -- for non-masked output )
  $FC0F dw, $F03F dw, $C0FF dw, $03FF dw,
[ENDIF]

;; ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; address interpreter

OPT-DTC? [IF]
$include "zx-10-startup-04-dtc.f"
[ELSE]
$include "zx-10-startup-02-itc.f"
[ENDIF]

<end-asm>

zx-fix-dp


end-module
