;; ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Z80 Abersoft fig-FORTH recompiled
;; Copyright (C) 2024 Ketmar Dark // Invisible Vector
;; Understanding is not required. Only obedience.
;; GPLv3 ONLY
;; ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; basic primitives
;; ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;


<zx-definitions>

;; uservar order is IMPORTANT!

<zx-system>
" i-next" z80-labman:@get constant NEXT
" i-next-push-hl" z80-labman:@get constant PUSHHL
" i-next-push-de-hl" z80-labman:@get constant PUSHDE

" zx-uv" z80-labman:@get constant (UV0)

;; is IM2 mode active?
false constant IM2?

zx-s0 tcom:zx-uservar (S0)
zx-r0 tcom:zx-uservar (R0)

;; case-sensitive system?
false quan CSENS?

0 vect QUIT
0 vect MAIN

23560 constant-and-label LAST-K sysvar-last-k
<zx-hidden>
\ LAST_K   equ $5C08
\ REP_DEL  equ $5C09
\ K_REPPER equ $5C0A
$5B5C label sysvar-bankm
$5B67 label sysvar-bank678

$5B5C label sysvar-cur-7FFD
$5B67 label sysvar-cur-1FFD

23608 constant-and-label RASP sysvar-rasp
23609 label sysvar-pip
23610 constant-and-label ERR-NR sysvar-err-nr   ;; IY points here
23611 label sysvar-flags
23613 label sysvar-err-sp
23617 constant-and-label TV-FLAG sysvar-tv-flag
\ 23624 constant-and-label BORDCR sysvar-bordcr
23633 label sysvar-curchl
23658 constant-and-label FLAGS2 sysvar-flags2
23659 label sysvar-defsz
23672 constant-and-label FRAMES sysvar-frames
23675 constant UDG^
23677 label sysvar-coords ;; x, then y
23677 label sysvar-coords-x
23678 label sysvar-coords-y
23684 constant-and-label DF-CC sysvar-df-cc   ;; scr$ for print
23688 constant-and-label S-POSN-X sysvar-s-posn-x ;; 33 minus print pos x
23689 constant-and-label S-POSN-Y sysvar-s-posn-y ;; 24 minus print pos y
23692 label sysvar-scr-ct     ;; scroll count
;; bits 0-2: ink
;; bits 3-5: paper
;; bit 6: bright
;; bit 7: flash
23693 constant-and-label ATTR-P sysvar-attr-p
23694 constant-and-label MASK-P sysvar-mask-p
23695 constant-and-label ATTR-T sysvar-attr-t
23696 constant-and-label MASK-T sysvar-mask-t
;; bit 0: over-p
;; bit 1: over-t
;; bit 2: inverse-p
;; bit 3: inverse-t
;; bit 4: ink9-p
;; bit 5: ink9-t
;; bit 6: paper9-p
;; bit 7: paper9-t
23697 constant-and-label P-FLAG sysvar-p-flag
<zx-normal>

<zx-forth>

false constant 128?   -- will be set to 1 for 128K machine
false constant +3DOS? -- will be set to 1 if +3DOS is present

\ 0 uservar FLD -- not used in FIG
10 uservar BASE
 0 uservar BLK
 0 uservar DPL
 0 uservar HLD

0 uservar IN
zx-query-tib uservar TIB

;; this is not used by the system.
;; intended to hold a pointer to task data.
0 uservar TSK

;; i'm not sure about user/globals yet...
OPT-EDITOR-CODE? [IF]
0 variable R# -- this is only used in EDITOR
[ENDIF]
0 variable SCR  -- used by LIST and EDITOR/FSEDITOR

;; no more uservars beyond this point


<zx-system>
tcom:zx-dp^ constant (DP)
tcom:zx-state^ constant STATE
tcom:zx-fence^ constant FENCE
tcom:zx-voclink^ constant VOC-LINK
<zx-forth>

tcom:zx-context^ constant CONTEXT
tcom:zx-current^ constant CURRENT

<zx-system>
;; A constant that leaves the address of the first (lowest) block buffer.
zx-buffer-first constant FIRST
;; A constant leaving the address just above the highest memory address used
;; by the system.
zx-buffer-limit constant LIMIT

OPT-BLOCK-I/O-TYPE R/W-TAPE = [IF]
zx-buffer-lo constant LO
zx-buffer-hi constant HI
[ENDIF]

;; A user variable which may contain a block offset for the RAM-disc.
;; The contents of OFFSET is added to the stack number by BLOCK.
;; Messages printed by MESSAGE are independent of OFFSET.
;; See BLOCK, MESSAGE.
0 variable OFFSET
;; A variable containing the address of the buffer most recently referenced.
;; The UPDATE command marks this buffer to be later written to external storage.
zx-buffer-first variable PREV ;; will be reset in COLD
;; A variable containing the address of the block buffer to use next, as the
;; least recently written.
zx-buffer-first variable USE  ;; will be reset in COLD

<zx-forth>
;; for "WHERE"
0 quan ERR-BLK
0 quan ERR-POS

;; This constant leaves the number of bytes per disc buffer, the byte count
;; read from disc by BLOCK.
zx-i/o-buf-size constant B/BUF
;; Internally, there are 4 additional bytes per buffer.
;; First 2 bytes is block number. Last 2 bytes are always 0.
;; Last 2 zero bytes are required to use the buffer as input source.
zx-i/o-buf-full-size constant B/BUF-FULL
;; A constant returning the number of disc buffers allocated.
zx-i/o-buf-count constant #BUFF
;; This constant leaves the number of blocks per editing screen. By
;; convention, an editing screen is 1024 bytes organised as 16 lines of 64
;; characters each.
zx-b/scr constant B/SCR
;; Chars in one screen line.
64 constant C/L
;; Number of lines in one screen.
16 constant L/SCR
;; Number of bytes in one screen.
1024 constant #SCR

0 constant 0
1 constant 1
;; bigger by ~3 bytes
\ 2 constant 2
;; this constant makes the code bigger by 2 bytes, lol
\ 3 constant 3
;; but this makes the code smaller by 5 bytes ;-)
-1 constant -1

0 constant FALSE
1 constant TRUE

32 constant BL
\ 13 constant NL

<zx-system>
31 variable WIDTH
0 variable WARNING

0 variable CSP
<zx-forth>


;; ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; lit, branch

code|: (BP)
  zxemut-bp
;code

code|: (PAUSE)
  zxemut-pause
;code

code|: (MSPD-ON)
  zxemut-max-speed
;code

code|: (MSPD-OFF)
  zxemut-normal-speed
;code

code|: (TS-RESET)
  zxemut-reset-ts-counter
;code

code|: (TS-PAUSE)
  zxemut-pause-ts-counter
;code

code|: (TS-RESUME)
  zxemut-resume-ts-counter
;code

code|: (TS-PRINT)
  zxemut-print-ts-counter
;code



OPT-ZXEMUT-DPRINT? [IF]
code: ZEMIT  ( ch )
  pop   hl
  ld    a, l
  ld    hl, # zxemut-zemit-was-cr
  cp    # 2
  jr    nz, # .not-endcr
  ld    a, (hl)
  or    a
  jp    nz, # i-next
  ld    a, # 10
.not-endcr:
  ld    (hl), # 0
  cp    # 10
  jr    nz, # .not-10
  inc   (hl)
.not-10:
  cp    # 13
  jr    nz, # .not-13
  inc   (hl)
.not-13:
flush!
  ;; ZXEmuT trap
  $ED db, $FE db, $18 db,
  2 db, $03 db, $00 db,
flush!
  next
flush!
zxemut-zemit-was-cr: 0 db,
;code
[ENDIF]


;; wait about ms milliseconds.
;; drifts a little, and tuned to IM 1 and contended memory.
code: MS  ( ms )
  pop   de
  ld    a, d
  or    e
  jp    z, # i-next
.loop-0:
  ld    a, # 153    ;; was 171; decreased due to contended memory and such
.loop-1:
  nop
  dec   a
  jp    nz, # .loop-1
  dec   de
  ld    a, d
  or    e
  jp    nz, # .loop-0
zx-ll-words-next:
;code

code: EI
  ei
  jr    # zx-ll-words-next
;code-no-next

code: DI
  di
  jr    # zx-ll-words-next
;code-no-next

code: HALT
  HALT
  jr    # zx-ll-words-next
;code-no-next


<zx-system>
code: LIT  ( -- n )
  ld    a, (bc)
  inc   bc
  ld    l, a
  ld    a, (bc)
  inc   bc
  ld    h, a
;code-push-hl

OPT-CLIT? [IF]
code: CLIT  ( -- n )
  ld    h, # 0
  ld    a, (bc)
  inc   bc
  ld    l, a
;code-push-hl
[ENDIF]

OPT-BLIT? [IF]
code: BLIT  ( -- n )
  ld    h, # $FF
  ld    a, (bc)
  inc   bc
  ld    l, a
;code-push-hl
[ENDIF]


;; used in "OF"
code: (OF<>)  ( a b -- a a-b )
  pop   hl
  pop   de
  push  de
  or    a
  sbc   hl, de
;code-push-hl


code: BRANCH
  ld    hl, bc
 OPT-REL-BRANCH? [IF]
  ld    e, (hl)
  inc   hl
  ld    d, (hl)
  dec   hl
  add   hl, de
  ld    bc, hl
 [ELSE]
  ld    c, (hl)
  inc   hl
  ld    b, (hl)
 [ENDIF]
;code

code: 0BRANCH  ( n )
  pop   hl
  ld    a, l
  or    h
  jp    z, # zx-word-branch
  inc   bc
  inc   bc
;code

code: TBRANCH  ( n )
  pop   hl
  ld    a, l
  or    h
  jp    nz, # zx-word-branch
  inc   bc
  inc   bc
;code
<zx-forth>


;; ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; exit

<zx-system>
code: ;S
zx-word-s-semi:
  ld    hl, () zx-rp
  ld    c, (hl)
  inc   hl
  ld    b, (hl)
  inc   hl
  ld    zx-rp (), hl
;code
<zx-forth>

\ alias-for ;S is EXIT
code: EXIT
  jr    # zx-word-s-semi
;code-no-next

code: ?EXIT  ( n )
  pop   hl
  ld    a, h
  or    l
  jr    nz, # zx-word-s-semi
;code

code: NOT?EXIT  ( n )
  pop   hl
  ld    a, h
  or    l
  jr    z, # zx-word-s-semi
;code


;; ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; basic stack manipulations

<zx-system>
code: SP@  ( -- sp )
  ld    hl, # 0
  add   hl, sp
;code-push-hl

code: SP!
  ld    hl, () zx-uv
  ld    de, # zx-uvar-ofs (S0)
  add   hl, de
  ld    a, (hl)
  inc   hl
  ld    h, (hl)
  ld    l, a
  ld    sp, hl
;code

code: DEPTH  ( -- stack-depth )
  ld    hl, () zx-uv
  ld    de, # zx-uvar-ofs (S0)
  add   hl, de
  ld    a, (hl)
  inc   hl
  ld    h, (hl)
  ld    l, a
  or    a
  sbc   hl, sp
  rr    h
  rr    l
;code-push-hl

code: RP@  ( -- rp )
  ld    hl, () zx-rp
;code-push-hl

code: RP!
  ld    hl, () zx-uv
  ld    de, # zx-uvar-ofs (R0)
  add   hl, de
  ld    a, (hl)
  inc   hl
  ld    h, (hl)
  ld    l, a
  ld    zx-rp (), hl
;code
<zx-forth>


;; ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; basic stack manipulations

code: 2DUP  ( a b -- a b a b )
  pop   hl  ;; b
  pop   de  ;; a
  push  de
  push  hl
;code-push-de-hl

code: 2DROP  ( a b )
  pop   hl
  pop   hl
;code

\ code: 4DROP  ( a b c d )
\   ;; almost 2 times faster than 4 POPs
\   ld    hl, # 8   ;; 10
\   add   hl, sp    ;; 11
\   ld    sp, hl    ;; 6
\   ;; 27
\ ;code

;; k8: sorry!
code: 2SWAP  ( a b c d -- c d a b )
  exx
  pop   de  ;; d
  pop   bc  ;; c
  exx
  pop   hl  ;; b
  pop   de  ;; a
zx-word-2swap-finish:
  exx
  push  bc
  push  de
  exx
;code-push-de-hl

;; k8: sorry!
code: 2OVER  ( a b c d -- a b c d a b )
  exx
  pop   de  ;; d
  pop   bc  ;; c
  exx
  pop   hl  ;; b
  pop   de  ;; a
  ;; now push
  push  de  ;; a
  push  hl  ;; b
  jr    # zx-word-2swap-finish
;code-no-next

;; SWAP DROP
code: NIP  ( a b -- b )
  pop   hl
  pop   de
;code-push-hl

;; SWAP OVER
code: TUCK  ( a b -- b a b )
  pop   hl  ;; b
  pop   de  ;; a
  push  hl
;code-push-de-hl

;; OVER SWAP
code: UNDER  ( a b -- a a b )
  pop   hl  ;; b
  pop   de  ;; a
  push  de
;code-push-de-hl

code: -DUP  ( a -- a a // 0 )
  pop   hl
  push  hl
  ld    a, h
  or    l
  jp    z, # i-next
;code-push-hl

alias-for -DUP is ?DUP  ( a -- a a // 0 )

code: -ROT  ( a b c -- c a b )
  pop   af  ;; c
  pop   hl  ;; b
  pop   de  ;; a
  jr    # zx-word-rot-finish
;code-no-next

alias-for -ROT is NROT  ( a b c -- c a b )

code: ROT  ( a b c -- b c a )
  pop   de  ;; c
  pop   af  ;; b
  pop   hl  ;; a
zx-word-rot-finish:
  push  af
;code-push-de-hl

code: OVER  ( a b -- a b a )
  pop   de
  pop   hl
  push  hl
;code-push-de-hl

code: SWAP  ( a b -- b a )
  pop   hl
  ex    (sp), hl
;code-push-hl

code: DROP  ( a )
  pop   hl
;code

code: DUP  ( a -- a a )
  pop   hl
  push  hl
;code-push-hl


;; ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; execute

code: EXECUTE  ( cfa )
  pop   hl
 OPT-DTC? [IF]
  jp    hl
 [ELSE]
  jp    # i-next-cfa-hl
 [ENDIF]
;code-no-next

code: EXECUTE-TAIL  ( cfa )
  ld    hl, () zx-rp
  ld    c, (hl)
  inc   hl
  ld    b, (hl)
  inc   hl
  ld    zx-rp (), hl
  jr    # zx-word-execute
;code-no-next


;; ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; loops

<zx-system>
code: (LOOP)
  ld    de, # 1
zx-word-addloop-do:
  ld    hl, () zx-rp
  ld    a, (hl)
  add   a, e
  ld    (hl), a
  ld    e, a
  inc   hl
  ld    a, (hl)
  adc   a, d
  ld    (hl), a
  inc   hl
  inc   d
  dec   d
  ld    d, a
  jp    m, # .skip0
  ld    a, e
  sub   (hl)
  ld    a, d
  inc   hl
  sbc   a, (hl)
  jp    # .skip1
.skip0:
  ld    a, (hl)
  sub   e
  inc   hl
  ld    a, (hl)
  sbc   a, d
.skip1:
  jp    m, # zx-word-branch
  inc   hl
  ld    zx-rp (), hl
  inc   bc
  inc   bc
;code

code: (+LOOP)  ( inc )
  pop   de
  jr    # zx-word-addloop-do
;code-no-next

code: (DO)  ( limit start )
zx-word-par-do:
  ld    hl, () zx-rp
  ld    de, # -4
  add   hl, de
  ld    zx-rp (), hl
  pop   de
  ld    (hl), e
  inc   hl
  ld    (hl), d
  pop   de
  inc   hl
  ld    (hl), e
  inc   hl
  ld    (hl), d
;code

code: (FOR)  ( limit )
  pop   hl
  ld    a, h
  or    a
  jp    m, # zx-word-branch
  or    l
  jp    z, # zx-word-branch
  push  hl
  ld    hl, # 0
  push  hl
  inc   bc
  inc   bc
  jr    # zx-word-par-do
;code-no-next
<zx-forth>

code: LEAVE
  ld    hl, () zx-rp
  ld    e, (hl)
  inc   hl
  ld    d, (hl)
  inc   hl
  ld    (hl), e
  inc   hl
  ld    (hl), d
;code

code: I'  ( -- n )
  ld    hl, () zx-rp
  inc   hl
  inc   hl
  jr    # zx-load-hl-word-and-push
;code-no-next

code: J  ( -- n )
  ld    hl, () zx-rp
  ld    de, # 4
  add   hl, de
  jr    # zx-load-hl-word-and-push
;code-no-next

code: I  ( -- loop-counter )
  ld    hl, () zx-rp
zx-load-hl-word-and-push:
  ld    e, (hl)
  inc   hl
  ld    d, (hl)
  push  de
;code


;; ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; return stack push, pop, peek, drop

alias-for I is R  ( | n -- n | n )
alias-for I is R@ ( | n -- n | n )

alias-for I' is R1@  ( | a b -- a | a b )
alias-for J is R2@  ( | a b c -- a | a b c )

code: R1!  ( a | n b -- | a b )
  ld    hl, () zx-rp
  inc   hl
  inc   hl
  pop   de
  ld    (hl), e
  inc   hl
  ld    (hl), d
;code

code: >R  ( n -- | n )
  pop   de
  ld    hl, () zx-rp
  dec   hl
  ld    (hl), d
  dec   hl
  ld    (hl), e
zx-next-store-hl-to-rp:
  ld    zx-rp (), hl
;code

code: R>  ( | n -- n )
  ld    hl, () zx-rp
  ld    e, (hl)
  inc   hl
  ld    d, (hl)
  inc   hl
  push de
  jr    # zx-next-store-hl-to-rp
;code-no-next

code: RDROP  ( | n -- )
  ld    hl, () zx-rp
  inc   hl
  inc   hl
  jr    # zx-next-store-hl-to-rp
;code-no-next


;; ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; digit conversion

code: DIGIT  ( c n1 -- n2 TRUE // FALSE )
  pop   hl
  pop   de
  ld    a, e
  sub   a, # $30
  jr    c, # .done
  cp    # 10
  jr    c, # .skip
  sub   a, # 7
  cp    # 10
  jr    c, # .done
.skip:
  cp    l
  jr    nc, # .done
  ld    e, a
  ld    hl, # 1
  next-push-de-hl
.done:
  ld    l, h
;code-push-hl


;; ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; input buffer scanning

;; The text scanning primitive used by WORD. From the text address addr1 and
;; an ascii delimiting character c, is determined the byte offset to the first
;; non-delimiter character `nd-ofs`, the offset to the first delimiter after the
;; text `end-ofs`, and the offset to the first character not included. This procedure
;; will not process past an ascii "null", treating it as an unconditional
;; delimiter.
<zx-system>
;; k8: with buffers bigger than 128 bytes, we need a better "ENCLOSE"
;; k8: so i completery rewrote this word.
code: ENCLOSE  ( addr c -- addr nd-ofs end-ofs end-ofs+1 )
  exx             ;; we need BC as a scratch register
  pop   de        ;; c
  pop   hl        ;; addr
  push  hl        ;; it won't change
  ld    bc, # -1  ;; current length
  dec   hl
  ;; skip delimiters
.delim-loop:
  inc   hl
  inc   bc
  ld    a, (hl)
  or    a
  jr    z, # .found-0
  cp    e
  jp    z, # .delim-loop
  ;; we found first non-delimiting char
  push  bc        ;; store nd-ofs
  ;; skip non-delimiters (but not too much)
  ld    d, # 0
.non-delim-loop:
  inc   hl
  inc   bc
  ld    a, (hl)
  or    a
  jr    z, # .found-word-end
  cp    e
  jr    z, # .found-word-end
  inc   d
  jp    p, # .non-delim-loop
.found-word-end:
  push  bc        ;; store end-ofs
  inc   bc
  push  bc        ;; store end-ofs+1
  exx
  next
.found-0:
  push  bc
  inc   bc
  jr    # .found-word-end
;code-no-next
<zx-forth>


;; ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; memory copying and filling

code: CMOVE  ( asrc adest acount )
  exx
  pop   bc        ;; count
  pop   de        ;; dest
  pop   hl        ;; src
  ld    a, b
  or    c
  jr    z, # zx-word-cmove-final-exit
  ldir
zx-word-cmove-final-exit:
  exx
;code

;; can be used to make some room.
;; moves from the last byte to the first one.
CODE: CMOVE>  ( from to len )
  exx
  pop   bc        ;; count
  pop   de        ;; dest
  pop   hl        ;; src
  ld    a, b
  or    c
  jr    z, # zx-word-cmove-final-exit
  ;; move both pointers to the end
  dec   bc
  add   hl, bc
  ex    de, hl
  add   hl, bc
  ex    de, hl
  inc   bc
  lddr
  jr    # zx-word-cmove-final-exit
;code-no-next

(*
: MOVE  ( from to len )
  >R 2DUP U> IF
    ;; from > to: use normal CMOVE
    R> CMOVE EXIT ENDIF
  ;; from <= to: use reverse CMOVE>
  R> CMOVE> ;
*)


code: FILL  ( addr len byte )
  exx
  pop   de  ;; byte
  pop   bc  ;; count
  pop   hl  ;; addr
  ;; HL: addr
  ;; DE: byte
  ;; BC: len
  ld    a, b
  or    a
  jr    nz, # .doit
  dec   c
  jp    m, # zx-word-cmove-final-exit
  ld    (hl), e
  jr    z, # zx-word-cmove-final-exit
  inc   c
.doit:
  ld    (hl), e
  dec   bc
  ld    de, hl
  inc   de
  ldir
  jr    # zx-word-cmove-final-exit
;code-no-next


;; ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; dictionary searching

code: UPCHAR  ( ch -- ch )
  pop   hl
  ld    a, l
  cp    # [char] a
  jr    c, # .bad-char
  cp    # [char] z 1+
  jr    nc, # .bad-char
  xor   # $20
.bad-char:
  ld    l, a
;code-push-hl


code: UPSTR  ( cstr )
  pop   hl
  ld    a, (hl)
  or    a
  jr    z, # .done
  ld    e, b
  ld    b, a
.loop:
  inc   hl
  ld    a, (hl)
  cp    # [char] a
  jr    c, # .bad-char
  cp    # [char] z 1+
  jr    nc, # .bad-char
  xor   # $20
  ld    (hl), a
.bad-char:
  djnz  # .loop
  ld    b, e
.done:
;code


;; Searches the dictionary starting at the name field address addr2, matching
;; to the text at addr1. Returns parameter field address, length byte of name
;; field and true for a good match. If no match is found, only a boolean false
;; is left.

OPT-NEW-ART-HEADER? [IF]

;; hash name
;; masks length to 5 bits
OPT-NEW-ART-HEADER-HASHED? [IF]
<zx-system>
code: HASH-NAME  ( addr count -- u8 )
  pop   de
  pop   hl
  ld    a, e
  call  # zx-hash-name-subr
  ld    l, a
  ld    h, # 0
  jp    # i-next-push-hl

;; IN:
;;   A: counter
;;  HL: addr
;; OUT:
;;   A: hash
zx-hash-name-subr:
  and   # $1F
  ret   z
  push  bc
  ld    b, a
  xor   a
.hloop:
  0 [IF]
    ld    c, (hl)
    inc   hl
    res   7, c
    set   5, c
    rlca
    sub   a, c
  [ELSE]
    rlca
    sub   a, (hl)
    inc   hl
  [ENDIF]
  djnz  # .hloop
  pop   bc
  ret
;code-no-next
<zx-forth>
[ENDIF]

;; addr2 is LFA here
<zx-system>
code: (FIND)  ( addr1 addr2 -- pfa b TRUE // FALSE )
  pop   de
  pop   hl
  ;; sanity checks
  ld    a, (hl)
  or    a
  jr    z, # .bad-input-length
  cp    # 32
  jr    nc, # .bad-input-length
 OPT-NEW-ART-HEADER-HASHED? [IF]
  push  hl
  inc   hl
  call  # zx-hash-name-subr
  ld    zx-word-par-find-nhash (), a
  pop   hl
 [ENDIF]
.main-loop:
  ;; check name hash
 OPT-NEW-ART-HEADER-HASHED? [IF]
  dec   de
  ld    a, (de)
  inc   de
  cp    # $FF   ;; self-modifying code
$here 1- @def: zx-word-par-find-nhash
  jr    nz, # .bad-name-hash
 [ENDIF]
  ;; move to NFA
  inc   de
  inc   de
  ;; DE=nfa
  ;; HL=name-cstr
  ;; check name length
  ld    a, (de)
  xor   (hl)
  and   # $3F
  jr    nz, # .skip-bad-length
  ;; length is ok, compare bytes
  push  hl  ;; name-cstr
  push  de  ;; nfa
.name-cmp-loop:
  inc   de
  inc   hl
  ld    a, (de)
  xor   (hl)
  add   a, a  ;; move bit 7 to carry
  jr    nz, # .skip-bad-name
  jp    nc, # .name-cmp-loop  ;; mostly taken
  ;; ok, the name is good
  ;; load first name byte, we need it
  pop   hl
  ld    a, (hl)
  ;; we don't heed HL anymore, drop it
  pop   hl
  ;; move to PFA
  OPT-DTC? [IF]
    ld    hl, # 4
  [ELSE]
    ld    hl, # 3
  [ENDIF]
  add   hl, de
  push  hl
  ld    e, a
  ld    d, # 0
  ld    hl, # 1
  jp    # i-next-push-de-hl
.bad-input-length:
  ld    hl, # 0
  jp    # i-next-push-hl
 OPT-NEW-ART-HEADER-HASHED? [IF]
.bad-name-hash:
  ex    de, hl
  ;; HL=lfa
  ;; DE=name-cstr
  ld    a, (hl)
  inc   hl
  ld    h, (hl)
  ld    l, a
  or    h
  ;; as it is mostly taken, do it this way
  ex    de, hl  ;; restore registers
  jp    nz, # .main-loop
  jr    # .not-found
 [ENDIF]
.skip-bad-name:
  pop   de
  pop   hl
.skip-bad-length:
  ex    de, hl
  ;; HL=nfa
  ;; DE=name-cstr
  dec   hl
  ld    a, (hl)
  dec   hl
  ld    l, (hl)
  ld    h, a
  or    l
  ;; as it is mostly taken, do it this way
  ex    de, hl  ;; restore registers
  jp    nz, # .main-loop
.not-found:
  ;; DE is 0 here
  push  de
;code
<zx-forth>

[ELSE]
;; original code
;; addr2 is NFA here
<zx-system>
code: (FIND)  ( addr1 addr2 -- pfa b TRUE // FALSE )
  pop   de
.main-loop:
  pop   hl
  push  hl
  ;; DE=nfa
  ;; HL=name-cstr
  ld    a, (de)
  xor   (hl)
  and   # $3F
  jr    nz, # .skip-nfa
.name-cmp-loop:
  inc   hl
  inc   de
  ld    a, (de)
  xor   (hl)
  add   a, a
  jr    nz, # .wrong-name
  jr    nc, # .name-cmp-loop
  ;; HL is at the end of NFA
 OPT-DTC? [IF]
  ld    hl, # 6
 [ELSE]
  ld    hl, # 5
 [ENDIF]
  add   hl, de
  ex    (sp), hl
.nfa-back:
  dec   de
  ld    a, (de)
  or    a
  jp    p, # .nfa-back
  ld    e, a
  ld    d, # 0
  ld    hl, # 1
  next-push-de-hl
.wrong-name:
  jr    c, # .at-lfa
.skip-nfa:
  inc   de
  ld    a, (de)
  or    a
  jp    p, # .skip-nfa
.at-lfa:
  inc   de
  ex    de, hl
  ld    e, (hl)
  inc   hl
  ld    d, (hl)
  ld    a, d
  or    e
  jr    nz, # .main-loop
  pop   hl
  ld    hl, # 0
;code-push-hl
<zx-forth>
[ENDIF]


<zx-done>
