;; ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Z80 Abersoft fig-FORTH recompiled
;; Copyright (C) 2024 Ketmar Dark // Invisible Vector
;; Understanding is not required. Only obedience.
;; GPLv3 ONLY
;; ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; memory access primitives
;; ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;


<zx-definitions>

code: 2@  ( addr -- d )
  pop   hl
  inc   hl
  inc   hl
  ld    e, (hl)
  inc   hl
  ld    d, (hl)
  push  de
  dec   hl
  dec   hl
  ld    d, (hl)
  dec   hl
  ld    e, (hl)
  push  de
;code

code: 2!  ( d addr )
  pop   hl
  pop   de
  ld    (hl), e
  inc   hl
  ld    (hl), d
  inc   hl
  pop   de
  ld    (hl), e
  inc   hl
  ld    (hl), d
;code


code: COUNT  ( addr -- addr+1 b[addr] )
  pop   hl
  ld    a, (hl)
zx-word-count-finish:
  inc   hl
  push  hl
  ld    l, a
  ld    h, # 0
;code-push-hl

alias-for COUNT is C@++  ( addr -- addr+1 b[addr] )

code: +!  ( value addr )
  pop   hl
  pop   de
zx-word-add-store-finish:
  ld    a, (hl)
  add   a, e
  ld    (hl), a
  inc   hl
  ld    a, (hl)
  adc   a, d
  ld    (hl), a
;code

;; 6 bytes
code: 1+!  ( value )
  pop   hl
  ld    de, # 1
  jr    # zx-word-add-store-finish
;code-no-next


code: @  ( addr -- value )
  pop   hl
  ld    e, (hl)
  inc   hl
  ld    d, (hl)
  push  de
;code

code: C@  ( addr -- byte )
  pop   hl
  ld    l, (hl)
  ld    h, # 0
;code-push-hl

code: !  ( value addr )
  pop   hl
  pop   de
zx-word-store-finish:
  ld    (hl), e
  inc   hl
  ld    (hl), d
;code

code: C!  ( byte addr )
  pop   hl
  pop   de
  ld    (hl), e
zx-word-cstore-exit:
;code

code: ON  ( addr )
  pop   hl
  ld    de, # 1
  jr    # zx-word-store-finish
;code-no-next

code: OFF  ( addr )
  pop   hl
  ld    de, # 0
  jr    # zx-word-store-finish
;code-no-next


;; Forth version is 14 bytes, this one is 8 (or even 7)
code: AND!C  ( val addr )
  pop   hl    ;; addr
  pop   de    ;; value
  ld    a, e
zx-word-log-andc-do:
  and   (hl)
zx-word-log-cstore-finish:
  ld    (hl), a
  jr    # zx-word-cstore-exit
;code-no-next

code: ~AND!C  ( val addr )
  pop   hl    ;; addr
  pop   de    ;; value
  ld    a, e
  cpl
  jr    # zx-word-log-andc-do
;code-no-next

code: OR!C  ( val addr )
  pop   hl    ;; addr
  pop   de    ;; value
  ld    a, e
  or    (hl)
  jr    # zx-word-log-cstore-finish
;code-no-next

code: XOR!C  ( val addr )
  pop   hl    ;; addr
  pop   de    ;; value
zx-word-xor-cstore:
  ld    a, e
  xor   (hl)
  jr    # zx-word-log-cstore-finish
;code-no-next

code: TOGGLE  ( addr byte )
  pop   de    ;; value
  pop   hl    ;; addr
  jr    # zx-word-xor-cstore
;code-no-next


<zx-done>
