;; ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Z80 Abersoft fig-FORTH recompiled
;; Copyright (C) 2024 Ketmar Dark // Invisible Vector
;; Understanding is not required. Only obedience.
;; GPLv3 ONLY
;; ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; high-level low-level words ;-)
;; ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;


<zx-definitions>
zx-here

OPT-ADVANCED-CFLOW? [IFNOT]
*: BEGIN  SYS: ?COMP HERE 1 ;
*: ENDIF  2 SYS: ?CPAIRS SYS: FWRD ;
\ *: THEN   [COMPILE] ENDIF ;
alias-for ENDIF is THEN zx-immediate

*: DO    SYS: ?COMP COMPILE SYS: (DO) HERE 3 ;
*: LOOP  3 SYS: ?CPAIRS COMPILE SYS: (LOOP) SYS: BACK ;
*: +LOOP 3 SYS: ?CPAIRS COMPILE SYS: (+LOOP) SYS: BACK ;

*: UNTIL   1 SYS: ?CPAIRS COMPILE SYS: 0BRANCH SYS: BACK ;
*: 0UNTIL  1 SYS: ?CPAIRS COMPILE SYS: TBRANCH SYS: BACK ;
\ alias-for UNTIL is END zx-immediate -- commented by k8

*: AGAIN  1 SYS: ?CPAIRS COMPILE SYS: BRANCH SYS: BACK ;
*: REPEAT >R >R [COMPILE] AGAIN R> R> 2- [COMPILE] ENDIF ;

*: IF     SYS: ?COMP COMPILE SYS: 0BRANCH SYS: BMARK 2 ;
*: 0IF    SYS: ?COMP COMPILE SYS: TBRANCH SYS: BMARK 2 ;
*: ELSE   2 SYS: ?CPAIRS COMPILE SYS: BRANCH SYS: BMARK SWAP 2 [COMPILE] ENDIF 2 ;

*: WHILE   [COMPILE] IF 2+ ;
*: 0WHILE  [COMPILE] 0IF 2+ ;

*: CASE  SYS: ?COMP SYS: CSP@ SYS: !CSP 4 ;
*: OF    4 SYS: ?CPAIRS COMPILE OVER COMPILE - COMPILE SYS: TBRANCH SYS: BMARK COMPILE DROP 5 ;
*: ENDOF 5 SYS: ?CPAIRS COMPILE SYS: BRANCH SYS: BMARK SWAP 2 [COMPILE] ENDIF 4 ;
*: ENDCASE
  4 SYS: ?CPAIRS COMPILE DROP
  BEGIN SYS: SP@ SYS: CSP@ = 0WHILE 2 [COMPILE] ENDIF REPEAT
  SYS: CSP! ;

[ELSE]

;; marks:
;;  1: BEGIN
;;  2: WHILE
;;  3: DO
;;  4: IF
;;  5: ELSE
;;  6: CASE
;;  7: OF
;;  8: OTHERWISE

|: (W/U-PROLOGUE)  ( brn )  >R 1 2 SYS: ?2PAIRS R> SYS: CALL, ;
|: (WHILE,)  ( brn )  (W/U-PROLOGUE) SYS: CHAIN> 2 ;
|: (UNTIL,)  ( brn )  (W/U-PROLOGUE) SWAP SYS: <RESOLVE SYS: RESOLVE> SYS: CSP! ;

*: BEGIN   SYS: ?COMP SYS: CSP@ SYS: <MARK ( fwd chain) 0 1 SYS: !CSP ;
*: WHILE   ['] 0BRANCH (WHILE,) ;
*: 0WHILE  ['] TBRANCH (WHILE,) ;
*: AGAIN   ['] BRANCH (UNTIL,) ;
\ *: REPEAT  [COMPILE] AGAIN ;
alias-for AGAIN is REPEAT zx-immediate
*: UNTIL   ['] 0BRANCH (UNTIL,) ;
*: 0UNTIL  ['] TBRANCH (UNTIL,) ;
\ alias-for UNTIL is END zx-immediate -- commented by k8


\ *: .S  ENDCR ." DEPTH=" DEPTH . CR DEPTH FOR SP@ I 2* + @ . LOOP CR ;

*: IF     SYS: ?COMP COMPILE SYS: 0BRANCH SYS: MARK> 4 ;
*: 0IF    SYS: ?COMP COMPILE SYS: TBRANCH SYS: MARK> 4 ;
*: ENDIF  4 5 SYS: ?2PAIRS SYS: RESOLVE> ;
\ *: THEN   [COMPILE] ENDIF ;
alias-for ENDIF is THEN zx-immediate
*: ELSE   4 SYS: ?CPAIRS COMPILE SYS: BRANCH SYS: MARK> SWAP SYS: RESOLVE> 5 ;


|: (LOOP,)  ( brn ) SWAP 3 SYS: ?CPAIRS SYS: CALL, SWAP SYS: <RESOLVE SYS: RESOLVE> SYS: CSP! ;

*: DO     SYS: ?COMP COMPILE SYS: (DO) SYS: CSP@ SYS: <MARK ( fwd chain) 0 3 SYS: !CSP ;
*: FOR    SYS: ?COMP COMPILE SYS: (FOR) SYS: CSP@ SYS: MARK> SYS: <MARK SWAP 3 SYS: !CSP ;
*: LOOP   ['] (LOOP) (LOOP,) ;
*: +LOOP  ['] (+LOOP) (LOOP,) ;


*: BREAK
  SYS: ?COMP SYS: CSP@ @ DUP 1 4 WITHIN 0= 19 ?ERROR
  3 - 0IF COMPILE SYS: RDROP COMPILE SYS: RDROP ENDIF  ;; clear stack for loops
  SYS: CSP@ 2+  ( chain> addr )
  DUP @ COMPILE SYS: BRANCH SYS: CHAIN> SWAP ! ;

*: CONTINUE
  SYS: ?COMP SYS: CSP@ @ 1 3 WITHIN 0= 19 ?ERROR
  SYS: CSP@ 4 + @ COMPILE SYS: BRANCH SYS: <RESOLVE ;


*: CASE     SYS: ?COMP SYS: CSP@ ( fwd chain) 0 6 SYS: !CSP ;
\ *: OF       6 SYS: ?CPAIRS COMPILE OVER COMPILE - COMPILE SYS: TBRANCH SYS: MARK> COMPILE DROP 7 ;
*: OF       6 SYS: ?CPAIRS COMPILE SYS: (OF<>) COMPILE SYS: TBRANCH SYS: MARK> COMPILE DROP 7 ;
*: ENDOF    7 SYS: ?CPAIRS COMPILE SYS: BRANCH SWAP SYS: CHAIN> SWAP SYS: RESOLVE> 6 ;
*: ENDCASE  DUP 6 8 SYS: ?2PAIRS 8 - IF COMPILE DROP ENDIF SYS: RESOLVE> SYS: CSP! ;

*: OTHERWISE  6 SYS: ?CPAIRS 8 ;

[ENDIF]

zx-here swap - endcr ." cflow words size: " .bytes cr
<zx-done>
