;; ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Z80 Abersoft fig-FORTH recompiled
;; Copyright (C) 2024 Ketmar Dark // Invisible Vector
;; Understanding is not required. Only obedience.
;; GPLv3 ONLY
;; ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; various other words
;; ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;


<zx-definitions>


: .S
  ?STACK
  BASE @ >R DECIMAL ." \cDEPTH=" DEPTH . CR
  DEPTH 16 MIN FOR
    I 0 .R ." : "
    SP@ I 2* + @
    DUP 6 .R 2 SPACES
    DUP 6 U.R 2 SPACES
    HEX 4 U.R DECIMAL CR
  LOOP R> BASE ! ;


code: BORDER  ( color )
  pop   hl
  ld    a, l
  and   a, # 07
  call  # $229B
;code

code: OUTP  ( value port )
  pop   hl
  pop   de
  push  bc
  ld    bc, hl
  ld    a, e
  out   (c), a
  pop   bc
;code

code: INP  ( port -- value )
  pop   hl
  push  bc
  ld    bc, hl
  in    a, (c)
  pop   bc
zx-word-inp-push-a:
  ld    h, # 0
  ld    l, a
;code-push-hl

(*
code: POINT  ( x y -- flag )
  pop   hl
  pop   de
  push  bc
  push  ix
  ld    c, e
  ld    b, l
  ld    a, l
  cp    # 176
  jr    c, # .ok
  ld    a, # 175
  ld    b, a
.ok:
  call  # $22CE
  call  # $1E94
  pop   ix
  pop   bc
  jr    # zx-word-inp-push-a
;code-no-next

code: PLOT  ( x y )
  pop   hl
  pop   de
  push  bc
  push  ix
  ld    c, e
  ld    b, l
  ld    a, h
  or    d
  jr    nz, # .skip
  ld    a, l
  cp    # 176
  jr    nc, # .skip
  call  # $22DF
.skip:
  pop   ix
  pop   bc
;code
*)


code: SCR$>ATTR  ( scr$ -- attr-addr )
  pop   hl
  ld    a, h
  or    # $87
  rra
  rra
  srl   a     ;; rra for #C000 screen
  ld    h, a
;code-push-hl

code: ATTR>SCR$  ( attr-addr -- scr$ )
  pop   hl
  ;; works for #C000 too
  ;; tnx, Lethargeek
  ld    a, h
  add   a
  add   a
  add   a
  and   h
  ld    h, a
zx-scvt-next-push-hl:
;code-push-hl


;; convert char coords to screen$ bitmap address.
code: CXY>SCR$  ( x y -- scr$ )
  pop   hl    ;; y
  pop   de    ;; x
  ld    a, h
  or    d
  ld    d, l
  ;; D=y, E=x
  ld    hl, # 0
  jr    nz, # zx-scvt-next-push-hl
  ld    a, e
  cp    # 32
  jr    nc, # zx-scvt-next-push-hl
  ld    a, d
  cp    # 24
  jr    nc, # zx-scvt-next-push-hl
  call  # zx-scr-char-coord-de
  jr    # zx-scvt-next-push-hl
;; IN:
;;   D: y
;;   E: x
;; OUT:
;;   HL: scr$addr
;;   DE: dead
;;   AF: dead
;;   carry flag: reset
zx-scr-char-coord-de:
  ld    a, d
  and   # $18
  or    # $40
  ld    h, a
  ld    a, d
  rrca
  rrca
  rrca
  and   # $E0
  or    e
  ld    l, a
  ret
;code-no-next

;; convert char coords to screen$ attribute address.
code: CXY>ATTR  ( x y -- attr-addr )
  pop   hl    ;; y
  pop   de    ;; x
  ld    a, h
  or    d
  ld    d, l
  ;; D=y, E=x
  ld    hl, # 0
  jr    nz, # zx-scvt-next-push-hl
  ld    a, e
  cp    # 32
  jr    nc, # zx-scvt-next-push-hl
  ld    a, d
  cp    # 24
  jr    nc, # zx-scvt-next-push-hl
  ld    a, d
;; IN:
;;   A: y
;;   E: x
;; OUT:
;;   HL: attr addr
;;   DE: dead
;;   AF: dead
;;   carry flag is reset
zx-scr-attr-coord-ea:
  rrca
  rrca
  rrca
  ld    d, a
  ;; low byte
  and   # $E0
  or    e
  ld    l, a
  ;; high byte
  ld    a, d
  and   # $03
  or    # $58
  ld    h, a
;code-push-hl


code: XY>SCR$  ( x y -- scr$ shift )
  pop   hl
  pop   de
  push  bc
  call  # zx-pix-addr-x-de-y-hl
  pop   bc
  jp    nc, # .valid
  ld    hl, # 0
  xor   a
.valid:
  push  hl
  jp    # zx-word-inp-push-a
;; calc screen address
;; IN:
;;   DE: x
;;   HL: y
;; OUT:
;;   HL: scr$
;;    A: bit number (from the msb; i.e. 0 means "$80")
;;   CARRY set on invalid coords
zx-pix-addr-x-de-y-hl:
  ;; calc screen address
  ;; IN:
  ;;   C: x
  ;;   A: y
  ;; OUT:
  ;;   HL: scr$
  ;;    A: bit number (from the msb; i.e. 0 means "$80")
  ld    a, d
  or    h
  scf
  ret   nz
  ld    a, l
  cp    # 192
  ccf
  ret   c
  ld    c, e
  jp    # $22B0
;code-no-next


;; down one pixel line.
;; WARNING! address must be valid!
code: SCR$V  ( scr$addr -- scr$addr )
  pop   hl
  (*
  inc   h
  ld    a, h
  and   # $07
  jp    nz, # i-next-push-hl
  ld    a, l
  add   a, # 32
  ld    l, a
  jp    c, # i-next-push-hl
  ld    a, h
  sub   # 8
  ld    h, a
  *)
  inc   h
  ld    a, h
  and   # $07
  jp    nz, # i-next-push-hl
  ld    a, l
  sub   # -32
  ld    l, a
  sbc   a, a
  and   # $F8
  add   a, h
  ld    h, a
;code-push-hl

;; up one pixel line
;; WARNING! address must be valid!
code: SCR$^  ( scr$addr -- scr$addr )
  pop   hl
  ld    a, h
  dec   h
  and   # $07
  jp    nz, # i-next-push-hl
  ld    a, l
  sub   # 32
  ld    l, a
  jp    c, # i-next-push-hl
  ld    a, h
  add   # 8
  ld    h, a
;code-push-hl


code: POINT  ( x y -- flag )
  pop   hl
  pop   de
  push  bc
  call  # zx-pix-addr-x-de-y-hl
  ld    b, a
  ld    a, (hl)
  jr    nc, # .ok
  xor   a
.ok:
  inc   b
.loop:
  rlca
  djnz  # .loop
  and   # $01
  pop   bc
  jp    # zx-word-inp-push-a
;code-no-next


;; ROM
code: PLOT  ( x y )
  pop   hl
  pop   de
  ;; check for negative coords
  ld    a, h
  or    d
  jp    nz, # i-next
  ;; check Y
  ld    a, l
  cp    # 192
  jp    nc, # i-next
  ;; coords are valid
  push  bc
  ld    b, l
  ld    c, e
  ld    sysvar-coords (), bc
  ;; ROM "PLOT" does unnecessary y check, skip it
  call  # $22B0
  call  # $22EC
  pop   bc
;code


;; doesn't touch attrs, ignores gover/inverse
code: PSET  ( x y on? )
  pop   hl        ;; on?
  ld    a, l
  or    h
  pop   hl        ;; y
  pop   de        ;; x
  ex    af, afx
  ;; check for negative coords
  ld    a, h
  or    d
  jp    nz, # i-next
  ;; check Y
  ld    a, l
  cp    # 192
  jp    nc, # i-next
  ;; coords are valid
  push  bc
  ;; calc screen address
  ;; IN:
  ;;   C: x
  ;;   A: y
  ;; OUT:
  ;;   HL: scr$
  ;;    A: bit number (from the msb; i.e. 0 means "$80")
  ld    c, e
  ld    a, l
  call  # $22B0
  ld    b, a
  inc   b
  ex    af, afx
  ld    e, a      ;; on?
  ld    a, # $01
.rotate-loop:
  rrca
  djnz  # .rotate-loop
  dec   e
  inc   e
  jr    z, # .do-reset
  ;; set point
  or    (hl)
  jr    # .done
.do-reset:
  cpl
  and   (hl)
.done:
  ld    (hl), a
  pop   bc
;code


;; doesn't touch attrs, ignores gover/inverse
code: PXOR  ( x y )
  pop   hl        ;; y
  pop   de        ;; x
  ex    af, afx
  ;; check for negative coords
  ld    a, h
  or    d
  jp    nz, # i-next
  ;; check Y
  ld    a, l
  cp    # 192
  jp    nc, # i-next
  ;; coords are valid
  push  bc
  ;; calc screen address
  ;; IN:
  ;;   C: x
  ;;   A: y
  ;; OUT:
  ;;   HL: scr$
  ;;    A: bit number (from the msb; i.e. 0 means "$80")
  ld    c, e
  ld    a, l
  call  # $22B0
  ld    b, a
  inc   b
  ld    a, # $01
.rotate-loop:
  rrca
  djnz  # .rotate-loop
  xor   (hl)
  ld    (hl), a
  pop   bc
;code


\ MIDPOINT CIRCLE ALGORITHM

<zx-hidden>
0 quan CX
0 quan CY
0 quan CP
0 quan CX1
0 quan CY1
0 quan PY
0 quan PXY
<zx-normal>

: CIRCLE  ( x y r )
  TO CX1 TO CY TO CX
  0 TO CP 0 TO CY1
  BEGIN CX1 CY1 < 0WHILE
    CP CY1 2* + 1+  TO PY
    PY CX1 2* - 1+  TO PXY
    CX CX1 + CY CY1 + PLOT
    CX CX1 - CY CY1 + PLOT
    CX CX1 + CY CY1 - PLOT
    CX CX1 - CY CY1 - PLOT
    CX CY1 + CY CX1 + PLOT
    CX CY1 - CY CX1 + PLOT
    CX CY1 + CY CX1 - PLOT
    CX CY1 - CY CX1 - PLOT
    PY TO CP 1 +TO CY1
    PXY ABS PY ABS < IF PXY TO CP -1 +TO CX1 ENDIF
  REPEAT ;


0 [IF]
<zx-hidden>
0 vect STEEP      \ NOOP or SWAP
0 vect YSTEP      \ 1+ or 1-
0 quan LY
0 quan DELTAX
0 quan DELTAY
<zx-normal>

: GLINE  ( x0 y0 x1 y1 )
  ROT SWAP  ( x0 x1 y0 y1 )
  2SWAP SWAP 2SWAP  ;; oops
  2DUP - ABS >R 2OVER - ABS R> <
  IF ['] SWAP ;; swap use of x and y
  ELSE 2SWAP ['] NOOP ENDIF
  TO STEEP  ( y0 y1 x0 x1 )
  2DUP >
  IF SWAP 2SWAP SWAP  ;; ensure x1 > x0
  ELSE 2SWAP ENDIF  ( x0 x1 y0 y1 )
  2DUP > IF ['] 1- ELSE ['] 1+ ENDIF TO YSTEP
  OVER - ABS TO DELTAY TO LY
  SWAP 2DUP - DUP TO DELTAX
  2/ ROT 1+ ROT ( error x1+1 x0 )
  DO
    I LY STEEP PLOT
    DELTAY - DUP 0< IF LY YSTEP TO LY DELTAX + ENDIF
  LOOP DROP ;

: DRAW  ( ex ey )  asm-label: sysvar-coords C@++ SWAP C@ 2SWAP GLINE ;

: DDRAW  ( dx dy )
  asm-label: sysvar-coords C@++ SWAP C@  ( dx dy x0 y0 )
  ROT OVER +  ( dy x0 y0 ey )
  2OVER + SWAP GLINE
  DROP ;


(*
;; this is mostly direct translation of the above code
;; it is quite fast for the fast case (when coords are in range)
code: GLINE  ( x0 y0 x1 y1 -- )
fword_dlf:
fword_fastline_8:
  ;; check plot mode
  ld    a, () plot_mode
  and   # $03
  jp    z, # fflfast_getout

  ld    hl, # ffline_doplot_or
  dec   a
  jr    z, # .pmode_done
  ld    hl, # ffline_doplot_xor
  dec   a
  jr    z, # .pmode_done
  ld    hl, # ffline_doplot_and
.pmode_done:
  ld    fflfast_pixdispatch_addr (), hl

  ;; use this to save BC
  exx

  pop   hl  ;; y1
  ld    fflfast_ycoord1 (), hl
  pop   hl  ;; x1
  ld    fflfast_xcoord1 (), hl
  pop   de  ;; y0
  ld    fflfast_ycoord0 (), de
  pop   hl  ;; x0
  ld    fflfast_xcoord0 (), hl

  ld    hl, () fflfast_ycoord1

  ;; dy=y1-y0
  \ or    a
  sbc   hl, de
  push  af        ;; we'll need carry flag later
  jp    p, # fflfast_dypos
  ;; negate hl
  xor   a
  sub   l
  ld    l, a
  sbc   a, a
  sub   h
  ld    h, a      ;; neg hl
fflfast_dypos:
  ld    fflfast_dy (), hl

  ;; err=(-dy)/2
  xor   a
  sub   l
  ld    l, a
  sbc   a, a
  sub   h
  ld    h, a      ;; neg hl
  sra   h
  rr    l
  ld    fflfast_err (), hl

  ;; put "DEC (HL)" or "INC (HL)" to sy
  ;; get back flags
  pop   af
  ld    a, # $34  ;; INC HL
  adc   a, # 0    ;; change to DEC HL if carry set (i.e. y0 > y1)
  ld    fflfast_sy (), a
  ;; setup UPHL or DOWNHL address
  ld    hl, # ffline_down_hl
  cp    # $34
  jr    z, # .downhlpatchok
  ld    hl, # ffline_up_hl
.downhlpatchok:
  ld    fflfast_updown_hl_addr (), hl

  ld    de, () fflfast_xcoord0
  ld    hl, () fflfast_xcoord1
  or    a
  sbc   hl, de    ;; hl=x1-x0
  push  af        ;; we'll need carry flag later
  jp    p, # fflfast_dxpos
  ;; negate hl
  xor   a
  sub   l
  ld    l, a
  sbc   a, a
  sub   h
  ld    h, a
fflfast_dxpos:
  ;; store dx to two places where we need it
  ld    dxval0 (), hl
  ld    dxval1 (), hl
  ld    bc, hl    ;; store |dx| to bc (temporarily)

  ;; put "DEC (HL)" or "INC (HL)" to sx
  ;; get back flags
  pop   af
  ld    a, # $34  ;; INC HL
  adc   a, # 0    ;; change to DEC HL if carry set (i.e. x0 > x1)
  ld    fflfast_sx (), a
  ld    fflfast_mask_move_addr (), a
  ;; patch mask shift instruction
  cp    # $34
  ld    a, # $0E  ;; RRC (HL)
  jr    z, # fflfast_xmaskpatch_ok
  ld    a, # $06  ;; RLC (HL)
fflfast_xmaskpatch_ok:
  ld    fflfast_mask_shift_addr (), a

  ld    hl, bc    ;; restore |dx|
  ld    de, () fflfast_dy
  or    a
  sbc   hl, de    ;; hl=dx-dy
  jr    c, # fflfast_dygrt
  ;; dx <= dy, change err to dx/2
  ld    hl, bc
  sra   h
  rr    l
  ld    fflfast_err (), hl  ;; then er=dx/2
fflfast_dygrt:

  ;; check if we need 16-bit coords
  ;; first, check high bytes
  ld    hl, # fflfast_xcoord0 1+
  ld    a, (hl)
  ;; 1
  inc   hl
  inc   hl
  or    (hl)
  ;; 2
  inc   hl
  inc   hl
  or    (hl)
  ;; 3
  inc   hl
  inc   hl
  or    (hl)
  jp    nz, # flslow_16
  ;; next, check if both y coords are in [0..191]
  ld    a, () fflfast_ycoord0
  cp    # 192
  jp    nc, # flslow_16
  ld    a, () fflfast_ycoord1
  cp    # 192
  jp    nc, # flslow_16
  ;; ok, we can use fast drawer
  ;; debug
  ;;jp    # flslow_16

  ;; prepare screen address and mask
  ld    hl, () fflfast_xcoord0
  ld    de, () fflfast_ycoord0 1-
  ld    e, l
  call  # scrpixcoord_de
  ld    fflfast_scraddr (), hl
  ;; create mask
  ld    d, a
  inc   d
  ld    a, # $01
.shift:
  rrca
  dec   d
  jp    nz, # .shift
  ld    fflfast_scrmask (), a

  ;; setup coords for comparisons
  ld    a, () fflfast_xcoord0
  ld    l, a
  ld    a, () fflfast_ycoord0
  ld    h, a
  ld    fflfast_xy0 (), hl

  ld    a, () fflfast_xcoord1
  ld    l, a
  ld    a, () fflfast_ycoord1
  ld    h, a
  ld    fflfast_xy1 (), hl

  ;; main loop
fflfast_loop:
  ;; put pixel
  ld    hl, # 0   ;; patched above
$here 2- @def: fflfast_scraddr
fflfast_loop_skip_hl_load:
  ld    a, # 0    ;; patched above
$here 1- @def: fflfast_scrmask
  call  # 0       ;; patched above
$here 2- @def: fflfast_pixdispatch_addr

  ;; check if we reached the destination
  ld    hl, # 0   ;; patched above
$here 2- @def: fflfast_xy0
  ld    de, # 0   ;; patched above
$here 2- @def: fflfast_xy1
  or    a
  sbc   hl, de
  jr    z, # fflfast_done

  ld    hl, # 0   ;; patched above
$here 2- @def: fflfast_err
  ld    bc, hl    ;; save err, we'll need it later
  ld    de, # 0   ;; will be patched
$here 2- @def: dxval0

  or    a
  adc   hl, de
  ld    de, # 0   ;; patched above
$here 2- @def: fflfast_dy
  jp    m, # fflfast_skipxmove  ;; err+dx>0: err-=dy
  ld    hl, bc
  or    a
  sbc   hl, de
  ld    fflfast_err (), hl
  ld    hl, # fflfast_xy0
  dec   (hl)      ;; patched above
$here 1- @def: fflfast_sx
  ;; move mask
  ld    hl, # fflfast_scrmask
  rrc   (hl)      ;; patched above
$here 1- @def: fflfast_mask_shift_addr
  jr    nc, # fflfast_mask_ok
  ld    hl, # fflfast_scraddr
  inc   (hl)      ;; patched above
$here 1- @def: fflfast_mask_move_addr
fflfast_mask_ok:

fflfast_skipxmove:
  ;; DE holds dy here
  ;; BC holds old err here
  ld    hl, bc
  or    a
  sbc   hl, de
  jp    p, # fflfast_loop     ;; olderr-dy<0: err+=dx
  ld    hl, () fflfast_err
  ld    de, # 0               ;; patched above
$here 2- @def: dxval1
  add   hl, de
  ld    fflfast_err (), hl    ;; er = er+dx
  ld    hl, # fflfast_xy0 1+
  inc   (hl)                  ;; patched above
$here 1- @def: fflfast_sy
  ;; change line address
  ld    hl, () fflfast_scraddr
  call  # 0                   ;;; patched above
$here 2- @def: fflfast_updown_hl_addr
  ld    fflfast_scraddr (), hl
  jp    # fflfast_loop_skip_hl_load

fflfast_done:
  exx
  next

fflfast_getout:
  pop   hl
  pop   hl
  pop   hl
  pop   hl
  next

ffline_down_hl:
  inc   h
  ld    a, h
  and   # $07
  ret   nz
  ld    a, l
  add   a, # 32
  ld    l, a
  ret   c
  ld    a, h
  sub   # 8
  ld    h, a
  ret

ffline_up_hl:
  ld    a, h
  dec   h
  and   # $07
  ret   nz
  ld    a, l
  sub   # 32
  ld    l,  a
  ret   c
  ld    a, h
  add   a, # 8
  ld    h, a
  ret


  ;; slow 16-bit drawer
flslow_16:
  call  # ffline_doplot_setup_mode

  ;; patch slow sx
  ld    a, () fflfast_sx
  cp    # $34         ;; INC (HL)
  ld    a, # $23      ;; INC HL
  jr    z, # flslow_sxpositive
  ld    a, # $2B      ;; DEC HL
flslow_sxpositive:
  ld    flslow_sx (), a
  ld    a, # $2B      ;; DEC HL

  ;; patch slow sy
  ld    a, () fflfast_sy
  cp    # $34         ;; INC (HL)
  ld    a, # $23      ;; INC HL
  jr    z, # flslow_sypositive
  ld    a, # $2B      ;; DEC HL
flslow_sypositive:
  ld    flslow_sy (), a
  ld    a, # $2B      ;; DEC HL

  ;; main loop
flslow_loop:
  ;; put pixel
  ld    hl, # fflfast_xcoord0 1+
  ld    a, (hl)
  inc   hl
  inc   hl
  or    (hl)
  jr    nz, # flslow_out_of_screen
  dec   hl
  ld    d, (hl)
  dec   hl
  dec   hl
  ld    e, (hl)
  call  # ffline_doplot_de
flslow_out_of_screen:

  ;; check if both coord pairs are equal
  ld    hl, () fflfast_xcoord0
  ld    de, () fflfast_xcoord1
  \ or    a
  sbc   hl, de
  jr    nz, # flslow_notdone
  ld    hl, () fflfast_ycoord0
  ld    de, () fflfast_ycoord1
  or    a
  sbc   hl, de
  jr    z, # fflfast_done
flslow_notdone:

  ld    hl, () fflfast_err
  ld    bc, hl      ;; save err, we'll need it later
  ld    de, () dxval0
  or    a
  adc   hl, de
  ld    de, () fflfast_dy
  jp    m, # flslow_skipxmove   ;; err+dx>0: err-=dy
  ld    hl, bc
  or    a
  sbc   hl, de
  ld    fflfast_err (), hl
  ld    hl, () fflfast_xcoord0
  dec   hl        ;; patched above
$here 1- @def: flslow_sx
  ld    fflfast_xcoord0 (), hl

flslow_skipxmove:
  ;; DE holds dy here
  ;; BC holds old err here
  ld    hl, bc
  or    a
  sbc   hl, de
  jp    p, # flslow_loop      ;; olderr-dy<0: err+=dx
  ld    hl, () fflfast_err
  ld    de, () dxval1
  add   hl, de
  ld    fflfast_err (), hl    ;; er = er+dx
  ld    hl, () fflfast_ycoord0
  inc   hl        ;; patched above
$here 1- @def: flslow_sy
  ld    fflfast_ycoord0 (), hl
  jp    # flslow_loop

fflfast_xcoord0: 0 dw,
fflfast_ycoord0: 0 dw,
fflfast_xcoord1: 0 dw,
fflfast_ycoord1: 0 dw,


;; this is shared between line and circle code
ffline_doplot_setup_mode:
  ;; check plot mode
  ld    a, () plot_mode
  and   # $03
  ret   z
  ld    hl, # ffline_doplot_or
  dec   a
  jr    z, # .pmode_done
  ld    hl, # ffline_doplot_xor
  dec   a
  jr    z, # .pmode_done
  ld    hl, # ffline_doplot_and
.pmode_done:
  ld    ffline_doplot_jaddr (), hl
  inc   a         ;; reset z flag
  ret

ffline_doplot_de:
  call  # scrpixcoord_de
  ret   c
  ;; create mask
  ld    d, a
  inc   d
  ld    a, # $01
.shift:
  rrca
  dec   d
  jp    nz, # .shift
ffline_doplot_dispatch:
  jp    # 0     ;; patched above
$here 2- @def: ffline_doplot_jaddr
ffline_doplot_and:
  cpl
  ld    e, a
  ld    a, (hl)
  and   e
  ld    (hl), a
  ret
ffline_doplot_xor:
  xor   (hl)
  ld    (hl), a
  ret
ffline_doplot_or:
  or    (hl)
  ld    (hl), a
  ret

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; convert pixel coords to screen$ bitmap address and shift
;; IN:
;;   D: y
;;   E: x
;; OUT:
;;   A: pixel shift (0: leftmost; i.e. shift for 0x80)
;;   HL: scr$addr
;;   DE: dead
;;   carry flag: set on error (and the result is for 0,0)
scrpixcoord_de:
  ld    a, d
  cp    # 192
  jr    nc, # scr_badcoord
  and   a
  rra
  scf
  rra
  and   a
  rra
  xor   d
  and   # $F8
  xor   d
  ld    h, a
  ld    a, e
  rlca
  rlca
  rlca
  xor   d
  and   # $C7
  xor   d
  rlca
  rlca
  ld    l, a
  ld    a, e
  and   # $07
  ret
scr_badcoord:
  ld    hl, # $4000
  xor   a
  scf
  ret
;code-no-next
*)


[ELSE]
<zx-hidden>
0 2variable INCX
0 2variable INCY
0 2variable X1
0 2variable Y1
<zx-normal>

: DRAW  ( ex ey )
  23678 C@ DUP 0 SWAP Y1 2! - DUP ABS ROT 23677 C@ DUP 0 SWAP X1 2! - DUP ABS ROT MAX >R
  DUP 0< IF ABS 0 SWAP R@ M/MOD DMINUS ELSE 0 SWAP R@ M/MOD ENDIF
  INCX 2! DROP DUP 0< IF ABS 0 SWAP R@ M/MOD DMINUS ELSE 0 SWAP R@ M/MOD ENDIF
  INCY 2! DROP R> 1+ FOR
    X1 @ Y1 @ PLOT
    X1 2@ INCX 2@ D+ X1 2!
    Y1 2@ INCY 2@ D+ Y1 2!
  LOOP ;

: DDRAW  ( dx dy )
  asm-label: sysvar-coords C@++ SWAP C@  ( dx dy x0 y0 )
  ROT OVER +  ( dy x0 y0 ey )
  2OVER + SWAP DRAW 2DROP
  DROP ;
[ENDIF]

: UDG  ( -- udgstart^ )  UDG^ @ ;

0 [IF]
: xf
  endcr
  32 BEGIN dup emit 1+ dup 128 < 0UNTIL drop cr ;
[ENDIF]

0 [IF]
: x00
  (MSPD-ON)
  SYS: FRAMES 1+ OFF SYS: FRAMES OFF
  BEGIN SYS: FRAMES @ 2- 0UNTIL
  SYS: FRAMES OFF
  10000 MS
  SYS: FRAMES @
  ." FRAMES=" DUP U.
  ." TIME: " 50 /MOD 0 .R 46 EMIT 20 * S>D <# # # # #> TYPE CR
  (MSPD-OFF) ERR-BEEP ;
[ENDIF]

0 [IF]
\ by Matteo Vitturi
4 constant m
0 quan x 0 quan y
: XM CR
  m 2* 1+ m 2* NEGATE DO
    i ABS TO y
    m 2* 1+ m 2* NEGATE DO
      i ABS TO x
      m x < m y < AND
      x y m - < OR
      y x m - < OR
      IF BL ELSE [CHAR] * ENDIF EMIT
    LOOP
  CR LOOP CR ;
[ENDIF]

0 [IF]
: RR BEGIN HALT 9 FOR 8 FOR I $FE OUTP LOOP LOOP ?TERMINAL UNTIL ;
[ENDIF]

0 [IF]
: boo ['] goo execute ." done\n" ;

: goo endcr ." GOO!\n" ;
[ENDIF]

0 [IF]
: jj ( josephus)  0 1 begin dup 30000 <= while swap 3 + over mod swap 1+ repeat drop ;
[ENDIF]


<zx-done>
