;; ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Z80 Abersoft fig-FORTH recompiled
;; Copyright (C) 2024 Ketmar Dark // Invisible Vector
;; Understanding is not required. Only obedience.
;; GPLv3 ONLY
;; ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; room (and tile) editor
;; tile property editor
;; included directly from "zx-90-apps-20-room-edit.f"
;; ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;


zx-here
;; ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; property editor
<zx-hidden>


(*
;; if set, attribute of this tile will override sprite attribute
$80 constant PMASK-A-FROZEN
;; if set, it is not allowed to print any sprites over this tile
$40 constant PMASK-S-FROZEN
;; if set, tile type is "frozen"
$20 constant PMASK-T-FROZEN
;; if set, tile attr is overriden
$10 constant PMASK-U-ATTR
*)

false quan pe-close?
0 quan pe-props
\ 0 quan pe-saved-hot-list
0 quan pe-saved-idle

|: pe-set-attrs  ( high? hidx )
  swap ?< @150 || @040 >? >r
  hcur-list hot-find not?exit< rdrop >?
  ( item^ )
  dup hot-xy-abs cxy>attr
  nrot hot-wh
  ( attr-addr w h | attr )
  for 2dup r2@ fill  32 + loop
  2drop rdrop ;

|: pe-set-props-attrs
  pe-props PMASK-A-FROZEN and 0 pe-set-attrs
  pe-props PMASK-S-FROZEN and 1 pe-set-attrs
  pe-props $0F and 16 for ( propidx )
    dup i =  i 2+ pe-set-attrs
  loop drop ;

|: pe-toggle
  hcur-udata <<
    -1 of?v| qaddr pe-props PMASK-A-FROZEN toggle |?
    -2 of?v| qaddr pe-props PMASK-S-FROZEN toggle |?
  else| dup 1 17 within not?< drop
        || 1- pe-props $F0 and or pe-props:! >? >>
  pe-set-props-attrs ;

\  pnames-buf block
create hot-prop-editor
  -1  1  0 " ATTR MASK" mk-hot-item
  -2 17  0 " TILE MASK" mk-hot-item
   1  0  2 " PROP #0     " mk-hot-item
   2 16  2 " PROP #1     " mk-hot-item
   3  0  4 " PROP #2     " mk-hot-item
   4 16  4 " PROP #3     " mk-hot-item
   5  0  6 " PROP #4     " mk-hot-item
   6 16  6 " PROP #5     " mk-hot-item
   7  0  8 " PROP #6     " mk-hot-item
   8 16  8 " PROP #7     " mk-hot-item
   9  0 10 " PROP #8     " mk-hot-item
  10 16 10 " PROP #9     " mk-hot-item
  11  0 12 " PROP #A     " mk-hot-item
  12 16 12 " PROP #B     " mk-hot-item
  13  0 14 " PROP #C     " mk-hot-item
  14 16 14 " PROP #D     " mk-hot-item
  15  0 16 " PROP #E     " mk-hot-item
  16 16 16 " PROP #F     " mk-hot-item
;hot-menu

false quan pe-names-loaded?

|: pe-fill-names
  pe-names-loaded? ?exit
  16 for
    pnames-buf block i 16 * +
    ( caddr )
    i 2+ hot-prop-editor hot-find not?exit< 0 >r >?
    drop 2drop 2drop
    (hot-fe-item^) 3 + 12 cmove
  loop
  true to pe-names-loaded? ;

: prop-editor  ( props -- props )
  false pe-close?:! pe-props:!
  hcur-hide
  \ hcur-list pe-saved-hot-list:!
  hot-reset
  qaddr arrow-idle @ pe-saved-idle:!
  ['] noop arrow-idle:!
  arrow-hide
  0 2 32 19 @040 ( save-wsp) make-window
  pe-fill-names
  hot-prop-editor hot-setup
  pe-set-props-attrs
  << ?ed-depth0
     hot-bt01!  ;; we want both buttons
     hot-menu-loop
     lastk@ 7 = ?v||
     hot-loop-bt1? ?v||
     hcur-udata ?< pe-toggle >?
  pe-close? not?^|| else| >>
  arrow-hide
  \ unshrink-window arrow-hide erase-window ( restore-wsp)
  fs-win \ draw-wk-room
  pe-props
  \ pe-saved-hot-list hot-setup
  pe-saved-idle arrow-idle:! ;


<zx-normal>
zx-here swap - endcr ." tile editor size: " .bytes cr
