;; ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Z80 Abersoft fig-FORTH recompiled
;; Copyright (C) 2024 Ketmar Dark // Invisible Vector
;; Understanding is not required. Only obedience.
;; GPLv3 ONLY
;; ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; eratos-test
;; ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;


<zx-definitions>

code: (EIM2)
etest-minimalistic-im2:
  ld    hl, () sysvar-frames
  inc   hl
  ld    sysvar-frames (), hl
  ret
;code-no-next


8192 constant pr-size
8192 zx-ud-buffer pr-flags

;; 15.600 with "2 *"
;; 12.440 with "2*"
: do-prime-orig  ( -- count )
  pr-flags pr-size -1 fill
  0 0 begin ( count index )
    dup pr-flags + c@
    if dup 2 * 3 + 2dup +
      begin dup pr-size < while dup pr-flags + 0 swap c! over + repeat 2drop
    swap 1+ swap endif
  1+ dup pr-size < not until
  drop ;

;; 11.900 for indirect branches
;; 11.620 for direct branches
;;  9.460 for DTC with indirect branches
;;  9.200 for DTC with direct branches
;;  7.960 for DTC with uncontended memory
: do-prime  ( -- count )
  pr-flags pr-size -1 fill
  0 0 begin ( count index )
    dup pr-flags + c@
    if dup 2* 3 + 2dup +
      begin dup pr-size < while dup pr-flags + 0 swap c! over + repeat 2drop
    [ OPT-UNDER-MATH? ] [IF]
      under+1
    [ELSE]
      swap 1+ swap
    [ENDIF]
    endif
  1+ dup pr-size - 0until
  drop ;

: xtest
  (mspd-on)
  [ OPT-IM2-HANDLER? ] [IF]
    DI
    asm-label: zx-im2-userproc-addr @ >R
    asm-label: zx-im2-rom-im1 C@ >R
    asm-label: etest-minimalistic-im2 asm-label: zx-im2-userproc-addr !
    0 asm-label: zx-im2-rom-im1 C!
    EI
  [ENDIF]
  ." \ctesting...\n"
  DI SYS: FRAMES off EI begin SYS: FRAMES @ 2 - 0until SYS: FRAMES off
  do-prime
  SYS: FRAMES @
  ." \ccount=" swap 0 .r
  ." \ctime: " dup 50 U/ 0 .r 46 emit 50 mod 20 * 0 <# # # # #> type cr
  [ OPT-IM2-HANDLER? ] [IF]
    DI
    R> asm-label: zx-im2-rom-im1 C!
    R> asm-label: zx-im2-userproc-addr !
    EI
  [ENDIF]
  (mspd-off) ;


<zx-done>
