;; ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Z80 Abersoft fig-FORTH recompiled
;; Copyright (C) 2024 Ketmar Dark // Invisible Vector
;; Understanding is not required. Only obedience.
;; GPLv3 ONLY
;; ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; host forwards for ZX words; used by TCOM control flow code
;; ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;


extend-module TCOM

: (zx-forward)  ( addr count doer )
  >r -1 nrot r> (mk-shadow-header) ;

: zx-forward
  parse-name ['] ss-forth-doer (zx-forward) ;


;; ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; define some forwards

<zx-shadow-system>
zx-forward LIT
OPT-CLIT? [IF]
zx-forward CLIT
[ENDIF]
OPT-BLIT? [IF]
zx-forward BLIT
[ENDIF]
zx-forward BRANCH
zx-forward 0BRANCH
zx-forward TBRANCH
zx-forward (DO)
zx-forward (FOR)
zx-forward (LOOP)
zx-forward (+LOOP)
zx-forward (")
zx-forward (.")
OPT-ZXEMUT-DPRINT? [IF]
zx-forward (Z.")
[ENDIF]
zx-forward ;S
zx-forward (OF<>)
OPT-ENABLE-FP? [IF]
zx-forward FP0!
[ENDIF]

<zx-shadow-forth>
zx-forward (CEMIT)
zx-forward RDROP
zx-forward DROP
zx-forward OVER
zx-forward -
zx-forward C,
zx-forward ,
zx-forward COMPILE
zx-forward EXIT

zx-forward 0>
zx-forward 0>=
zx-forward 0<
zx-forward 0<=


;; ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; compile zx literals

;; compile zx-cfa literal, take care of forwards
: zx-shadow-cfa-#,  ( shadow-cfa )
  zsys-run: LIT
  dart:cfa>pfa 0 ss-ofs, ;

;; compile zx-pfa literal, take care of forwards
: zx-shadow-pfa-#,  ( shadow-cfa )
  zsys-run: LIT
  dart:cfa>pfa zx-#cfa ss-ofs, ;

: zx-#,  ( n )
  dup -32768 65536 within not?error" ZX literal out of bounds"
  [ OPT-CLIT? OPT-BLIT? forth:or ] [IF]
    dup hi-byte <<
      [ OPT-CLIT? ] [IF]
        0 of?v| zsys-run: CLIT zx-c, zx-stat-clit-bytes-saved:1+! |?
      [ENDIF]
      [ OPT-BLIT? ] [IF]
      255 of?v| zsys-run: BLIT zx-c, zx-stat-blit-bytes-saved:1+! |?
      [ENDIF]
    else| drop zsys-run: LIT zx-w, >>
  [ELSE]
    zsys-run: LIT zx-w,
  [ENDIF] ;


end-module
