;; ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Z80 Abersoft fig-FORTH recompiled
;; Copyright (C) 2024 Ketmar Dark // Invisible Vector
;; Understanding is not required. Only obedience.
;; GPLv3 ONLY
;; ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; helper vocab with tcom words
;; this also compiles literals (the handler will be set later)
;; ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;


extend-module TCOM

module SHADOW-HELPERS
*: (  [\\] forth:( ;
*: \  [\\] forth:\ ;
*: -- [\\] forth:-- ;
*: // [\\] forth:// ;
*: (* [\\] forth:(* ;
*: (+ [\\] forth:(+ ;

*: [IF]     [\\] forth:[IF] ;
*: [IFNOT]  [\\] forth:[IFNOT] ;
*: [ELSE]   [\\] forth:[ELSE] ;
*: [ENDIF]  [\\] forth:[ENDIF] ;

*: RECURSE-TAIL
  zx-?in-colon
  zsys-run: BRANCH zx-latest-pfa zx-brdest, ;

*: RECURSE
  zx-?in-colon
  zx-latest-cfa zx-call, ;

\ *: FALSE  zx-?in-colon  0 zx-#, ;
\ *: TRUE   zx-?in-colon  1 zx-#, ;

*: [CHAR]
  zx-?in-colon
  parse-name 1 <> ?error" [CHAR] expects a char"
  c@ zx-#, ;

*: [COMPILE]
  zx-?in-colon
  parse-name
  2dup curr-shadow-vocid vocid-find not?<
    " ZX word \'" string:>pad string:pad+cc
    " \' not found!" string:pad+cc
    string:pad-cc@ error >?
  nrot 2drop execute ;

;; sadly, i have to made "COMPILE" like this.
;; the original wasn't even an immediate word.
*: COMPILE
  zx-?in-colon
  parse-name
  2dup " SYS:" string:=ci ?< 2drop
    parse-name
    [ OPT-SYS-VOCAB? ] [IF] vocid: system-shadows [ELSE] vocid: forth-shadows [ENDIF]
  || curr-shadow-vocid >?
  >r 2dup r> vocid-find not?<
    " ZX word \'" string:>pad string:pad+cc
    " \' not found!" string:pad+cc
    string:pad-cc@ error >?
  forth-shadows:compile execute 2drop ;

\ *: [\\]  forth:[\\] [COMPILE] ;
\ *: \,  forth:[\\] COMPILE ;

*: ."
  zx-?in-colon
  34 parse-qstr
  zsys-run: (.") zx-bstr, ;

OPT-ZXEMUT-DPRINT? [IF]
*: Z."
  zx-?in-colon
  34 parse-qstr
  zsys-run: (Z.") zx-bstr, ;
[ENDIF]

*: "
  zx-?in-colon
  34 parse-qstr
  zsys-run: (") zx-bstr, ;

*: ,"
  zx-?exec
  34 parse-qstr
  zx-bstr, ;

|: (mk#)  ( value )
  zx-?in-colon zx-#, ;

*: [ZX-DO-COLON]     zx-do-colon^ (mk#) ;
*: [ZX-DO-CONSTANT]  zx-do-constant^ (mk#) ;
*: [ZX-DO-2CONSTANT] zx-do-2constant^ (mk#) ;
*: [ZX-DO-VARIABLE]  zx-do-variable^ (mk#) ;
*: [ZX-DO-QUAN]      zx-do-quan^ (mk#) ;
*: [ZX-DO-VECT]      zx-do-vect^ (mk#) ;
*: [ZX-DO-QADDR]     zx-do-quan-addr^ (mk#) ;
*: [ZX-DO-Q-TO]      zx-do-quan-to^ (mk#) ;
*: [ZX-DO-Q-+TO]     zx-do-quan-add-to^ (mk#) ;
*: [ZX-DO-2VARIABLE] zx-do-2variable^ (mk#) ;
*: [ZX-DO-USERVAR]   zx-do-uservar^ (mk#) ;
*: [ZX-DO-VOCAB]     zx-do-vocab^ (mk#) ;
*: [ZX-DO-DOES]      zx-do-does^ (mk#) ;
*: [ZX-DO-ALIAS]     zx-do-alias^ (mk#) ;

end-module


end-module
