;; ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Z80 Abersoft fig-FORTH recompiled
;; Copyright (C) 2024 Ketmar Dark // Invisible Vector
;; Understanding is not required. Only obedience.
;; GPLv3 ONLY
;; ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; create code and colon ZX words
;; ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;


extend-module TCOM

;; ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; create ZX code word

|: define-zx-code-word-label  ( addr count )
  " zx-word-" string:>pad string:pad+cc
  string:pad-cc@ zx-here z80-labman:lbl-new
  z80-labman:reset-locals ;

*: zx-code:  \ name
  zx-compile-mode ?error" still compiling something"
  system:?exec zx-?exec
  parse-name
  2dup 2>r zx-mk-header
  2r@ ['] ss-code-doer mk-shadow-header
  ( cfa) -1 zx-cfa,
  zx-fix-org
  2r> define-zx-code-word-label
  [\\] <asm>
  push-ctx voc-ctx: zxf-code
  zxc-code zx-compile-mode:!
  ;; statistics
  zx-stats-code:1+!
  zx-here zx-stx-last-code-start:! ;

*: zx-code|:  \ name
  zx-headers-allowed? >r zx-headers-allowed?:!f
  [\\] zx-code:
  r> zx-headers-allowed?:! ;


;; ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; create ZX colon words

*: zx:  \ name
  zx-compile-mode ?error" still compiling something"
  system:?exec zx-?exec
  parse-name
  2dup 2>r zx-mk-header zx-smudge
  2r> ['] ss-forth-doer mk-shadow-header
  ( cfa) zx-do-colon^ zx-cfa,
  zx-fix-org
  push-ctx
  0 vsp-push
  vocid: forth-shadows vsp-push
  curr-shadow-vocid dup vocid: forth-shadows <> ?< vsp-push || drop >?
  \ zx-in-editor? ?< vocid: editor-shadows vsp-push >?
  vocid: shadow-helpers vsp-push
  voc-ctx: shadow-semi
  zx-comp!
  $c0de_0800
  zxc-colon zx-compile-mode:!
  ;; statistics
  zx-stats-colon:1+!
  zx-here zx-stx-last-colon-start:! ;

: zx*:  \ name
  [\\] zx: zx-immediate ;

: zx|:  \ name
  zx-headers-allowed? >r zx-headers-allowed?:!f
  [\\] zx:
  r> zx-headers-allowed?:! ;


end-module
