;; ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Z80 Abersoft fig-FORTH recompiled
;; Copyright (C) 2024 Ketmar Dark // Invisible Vector
;; Understanding is not required. Only obedience.
;; GPLv3 ONLY
;; ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; "<zx-definitions>" and "<zx-done>" support
;; ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;


extend-module TCOM

: (-zx-qaddr-scfa)  ( -- shadow-cfa )  \ name
  (-zx-find-ss-cfa)
  dup zx-forward? ?exit
  dup zx-quan? over zx-vect? or not?error" quan expected" ;


module ZX-DEFS
<disable-hash>

*: <zx-done>
  system:?exec zx-?exec
  pop-ctx
  context@ vocid: zx-defs = not?error" unfinished contexts"
  pop-ctx pop-ctx ;


*: create;  ;


*: sys:  \ name
  parse-name 2dup 2>r
  [ OPT-SYS-VOCAB? ] [IF] vocid: system-shadows [ELSE] vocid: forth-shadows [ENDIF]
  vocid-find not?<
    " unknown ZX word \'" string:>pad 2r> string:pad+cc
    " \'" string:pad+cc  string:pad-cc@ error >?
  2rdrop execute ;

*: editor:  \ name
  parse-name 2dup 2>r
  vocid: editor-shadows
  vocid-find not?<
    " unknown ZX word \'" string:>pad 2r> string:pad+cc
    " \'" string:pad+cc  string:pad-cc@ error >?
  2rdrop execute ;

*: asm-label:  ( -- value )  \ name
  parse-name z80-labman:@get
  zx-comp? ?< zx-#, >? ;

*: allot  ( size )
  zx-allot0 ;


*: qaddr
  system:?exec (-zx-qaddr-scfa)
  zx-comp? ?exit< dart:cfa>pfa zx-#cfa 2 + ss-ofs-call, >?
  ss-cfa-zx-cfa@ zx-#cfa + ;

*: to
  system:?exec (-zx-qaddr-scfa)
  zx-comp? ?exit< dart:cfa>pfa zx-#cfa 2 * 2 + ss-ofs-call, >?
  ss-cfa-zx-cfa@ zx-#cfa +
  zx-w! ;

*: +to
  system:?exec (-zx-qaddr-scfa)
  zx-comp? ?exit< dart:cfa>pfa zx-#cfa 3 * 2 + ss-ofs-call, >?
  ss-cfa-zx-cfa@ zx-#cfa +
  dup zx-w@ rot + swap zx-w! ;


extend-module zx-quan-mth

|: qaddr
  ?zx-quan
  zx-comp? ?exit< dart:cfa>pfa zx-#cfa 2 + ss-ofs-call, >?
  ss-cfa-zx-cfa@ zx-#cfa + ;

|: to
  ?zx-quan
  zx-comp? ?exit< dart:cfa>pfa zx-#cfa 2 * 2 + ss-ofs-call, >?
  ss-cfa-zx-cfa@ zx-#cfa +
  zx-w! ;

|: +to
  ?zx-quan
  zx-comp? ?exit< dart:cfa>pfa zx-#cfa 3 * 2 + ss-ofs-call, >?
  ss-cfa-zx-cfa@ zx-#cfa +
  dup zx-w@ rot + swap zx-w! ;

*: !  to ;
*: ^  qaddr ;
*: !0 zx-comp? ?< 0 zx-#, >? to ;
*: !1 zx-comp? ?< 1 zx-#, >? to ;
*: !t zx-comp? ?< 1 zx-#, >? to ;
*: +!  +to ;
*: -!  error" not defined" ;
*: 1+!  zx-comp? ?< 1 zx-#, >? +to ;
*: 1-!  zx-comp? ?< -1 zx-#, >? +to ;
end-module


*: [']  ( -- zx-cfa )  \ name
  system:?exec (-zx-find-ss-cfa)
  zx-comp? ?exit< zx-shadow-cfa-#, >?
  ss-cfa-zx-cfa@ ;

*: ['pfa]  ( -- zx-pfa )  \ name
  system:?exec (-zx-find-ss-cfa)
  zx-comp? ?exit< zx-shadow-pfa-#, >?
  ss-cfa-zx-cfa@ zx-#cfa + ;


*: c,  ( byte )
  system:?exec
  zx-comp? ?< forth-shadows:c, || zx-c, >? ;

*: ,  ( byte )
  system:?exec
  zx-comp? ?< forth-shadows:, || zx-w, >? ;


*: ,"
  zx-?exec
  34 parse-qstr
  zx-bstr, ;


*: mk-hot-item  ( udata x y addr count )
  zx-?exec
  2swap  swap zx-c, zx-c, ;; x and y
  zx-bstr,
  zx-w, ;

*: mk-hot-area  ( udata x y w h )
  zx-?exec
  2swap  swap zx-c, zx-c, ;; x and y
  swap negate zx-c, zx-c, ;; width and height
  zx-w, ;

*: ;hot-menu
  zx-?exec
  $80 zx-c, ;


alias-for zx-constant is constant
alias-for zx-constant-and-label is constant-and-label
alias-for zx-label is label
alias-for zx-quan is quan
alias-for zx-vect is vect
alias-for zx-variable is variable
alias-for zx-2variable is 2variable
alias-for zx-uservar is uservar
alias-for zx-create is create

alias-for zx-code: is code:
alias-for zx-code|: is code|:

alias-for zx: is :
alias-for zx|: is |:
alias-for zx*: is *:

alias-for zx-alias-for is alias-for

end-module


extend-module SHADOW-HELPERS
  alias-for zx-defs:sys: is sys:
  alias-for zx-defs:editor: is editor:
  alias-for zx-defs:to is to
  alias-for zx-defs:+to is +to
  alias-for zx-defs:qaddr is qaddr
  alias-for zx-defs:['] is [']
  alias-for zx-defs:['pfa] is ['pfa]
  alias-for zx-defs:asm-label: is asm-label:
end-module


: <zx-definitions>
  push-ctx voc-ctx: tcom
  push-ctx voc-ctx: zx-defs
  push-ctx voc-ctx: zx-consts
  <zx-normal> <zx-forth>
  <zx-shadow-forth> ;


end-module

;; publish it
alias-for tcom:<zx-definitions> is <zx-definitions>

