;; ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Z80 Abersoft fig-FORTH recompiled
;; Copyright (C) 2024 Ketmar Dark // Invisible Vector
;; Understanding is not required. Only obedience.
;; GPLv3 ONLY
;; ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; dictionary and article header creation
;; ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;


$include "tcom-20-creatori-10-base.f"

;; ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; host shadow dictionaries

(*
shadow word format:
  dd zx-cfa   ;; -1 means "forward reference"
  dd fix-chain-head  ;; for forward references; 0 for defined words
*)

extend-module TCOM

0
new-field ss>zxcfa
new-field ss>chain
constant #ss

module FORTH-SHADOWS
end-module

module EDITOR-SHADOWS
end-module

OPT-SYS-VOCAB? [IF]
module SYSTEM-SHADOWS
end-module
[ENDIF]

end-module

;; keep loading
$include "tcom-20-creatori-16-fixups.f"
$include "tcom-20-creatori-20-mk-shadow.f"
$include "tcom-20-creatori-22-mk-zx.f"
$include "tcom-20-creatori-26-zx-forwards.f"
$include "tcom-20-creatori-30-shadow-helpers.f"
$include "tcom-20-creatori-32-zxf-code-helpers.f"
$include "tcom-20-creatori-34-zxf-semi-helpers.f"
$include "tcom-20-creatori-36-mk-zx-code-colon.f"
$include "tcom-20-creatori-38-mk-zx-other.f"
$include "tcom-20-creatori-40-zx-mode.f"


extend-module TCOM

;; ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; SHADOWS vocab methods (compile literals, create forwards)

(*
: zx-voc-execcomp  ( cfa -- ... TRUE // FALSE )
\ endcr dup zx-cfa>nfa ." ZX: |" zx-.id ." |\n"
  zx-?comp
  dup zx-cfa>nfa zx-c@ zx-immediate-mask and ?<
    endcr ." cannot compile immediate ZX word \'" zx-cfa>nfa zx-.id ." \'!\n"
    abort >?
  zx-w, true ;
['] zx-voc-execcomp vocid: zxw system:vocid-execcomp-cfa!
*)

(*
: zx-voc-finder  ( addr count skip-hidden? vocid -- cfa-xt TRUE // FALSE )
  2drop zx-find ;
['] zx-voc-finder vocid: zxw system:vocid-find-cfa!
*)

|: zx-voc-literal  ( lit -- ... TRUE // lit FALSE )
  zx-comp? not?exit&leave
  system:?exec zx-#, true ;
['] zx-voc-literal vocid: forth-shadows system:vocid-literal-cfa!

;; automatically create forwards (Forth by default).
|: zx-voc-notfound  ( addr count -- processed-flag )
\ endcr ." ZX-NOTFOUND: |" 2dup type ." |\n"
  zx-comp? not?exit< 2drop false >?
  ss-mk-forth-forward dart:cfa>pfa ss-call,
  true ;
['] zx-voc-notfound vocid: forth-shadows system:vocid-notfound-cfa!


;; ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; create the very first ZX word ("FORTH")

;; create "FORTH" vocabulary word
: create-first-zx-word
  system:?exec zx-?exec
  zx-current^ not?error" ZX CURRENT is not defined"
  zx-context^ not?error" ZX CONTEXT is not defined"
  zx-voclink^ not?error" ZX VOCLINK is not defined"
  zx-here 64 + dup zx-current! zx-context!  ;; temporary
  0 zx-current@ zx-w!
  zx-here >r  ;; save NFA
  " FORTH" 2dup zx-mk-header
  ['] ss-vocab-doer mk-shadow-header
  \ ( cfa) zx-do-does^ zx-w,
  \ ( doer) zx-fix-org " zx-doer-vocab" z80-labman:ref-label,
  ( cfa) zx-do-vocab^ zx-cfa,
  [ OPT-NEW-ART-HEADER? ] [IF]
    zx-here zx-forth-vocid:!
    ( latest-lfa) zx-here dup zx-current! zx-context! r> zx-w,
  [ELSE]
    ( reserved) 0 zx-w,
  [ENDIF]
  ( dummy name) $A081 zx-w,
  [ OPT-NEW-ART-HEADER? ] [IFNOT]
    zx-here zx-forth-vocid:!
    ( latest-nfa) zx-here dup zx-current! zx-context! r> zx-w,
  [ENDIF]
  ( voc-link) zx-here 0 zx-w, zx-voclink^ zx-w!
  ( for some reason FORTH is immediate) zx-immediate ;

end-module
