;; ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Z80 Abersoft fig-FORTH recompiled
;; Copyright (C) 2024 Ketmar Dark // Invisible Vector
;; Understanding is not required. Only obedience.
;; GPLv3 ONLY
;; ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; TCOM conditions and loops
;; ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;


extend-module TCOM

extend-module SHADOW-HELPERS
<private-words>

0 quan (CSP)

: zx-CSP@  ( -- csp )  (csp) ;
: zx-CSP!  ( value  )  (csp):! ;
: zx-!CSP  forth:(sp@) zx-csp! ;

: zx-?CPAIRS  ( a b )  zx-?comp system:?pairs ;
: zx-?2PAIRS  ( pn n0 n1 )  zx-?comp ROT TUCK ( n0 pn n1 pn) - NROT - AND ?error" imbalance!" ;


<published-words>

(*
: BEGIN  zx-?comp zx-<j-mark 1 ;
: ENDIF  zx-?comp 2 ?pairs zx-resolve-j> ;

: DO     zsys-run: (DO) zx-<j-mark 3 ;
: LOOP   3 ?pairs zsys-run: (LOOP) zx-<j-resolve ;
: +LOOP  3 ?pairs zsys-run: (+LOOP) zx-<j-resolve ;

: UNTIL   1 ?pairs zsys-run: 0BRANCH zx-<j-resolve ;
: 0UNTIL  1 ?pairs zsys-run: TBRANCH zx-<j-resolve ;

: AGAIN  1 ?pairs zsys-run: BRANCH zx-<j-resolve ;
: REPEAT 2>r [\\] AGAIN 2r> 2- [\\] ENDIF ;

: IF     zsys-run: 0BRANCH zx-mark-j> 2 ;
: 0IF    zsys-run: TBRANCH zx-mark-j> 2 ;
: ELSE 2 ?pairs zsys-run: BRANCH zx-mark-j> swap zx-resolve-j> 2 ;

: WHILE   zsys-run: 0BRANCH zx-mark-j> 4 ;
: 0WHILE  zsys-run: TBRANCH zx-mark-j> 4 ;

: CASE  zx-?comp csp@ !csp 4 ;
: OF    4 ?pairs forth-shadows:OVER forth-shadows:- zsys-run: TBRANCH zx-mark-j> forth-shadows:DROP 5 ;
: ENDOF 5 ?pairs zsys-run: BRANCH zx-mark-j> swap 2 [\\] ENDIF 4 ;
: ENDCASE
  4 ?pairs forth-shadows:DROP
  << depth csp@ = not?^| 2 [\\] ENDIF |? else| >>
  csp! ;
*)

;; marks:
;;  1: BEGIN
;;  2: WHILE
;;  3: DO
;;  4: IF
;;  5: ELSE
;;  6: CASE
;;  7: OF
;;  8: OTHERWISE

|: (W/U-PROLOGUE)  ( brn-comiple-cfa )  >R 1 2 zx-?2PAIRS R> execute-tail ;
|: (WHILE,)  ( brn-comiple-cfa )  (W/U-PROLOGUE) zx-CHAIN> 2 ;
|: (UNTIL,)  ( brn-comiple-cfa )  (W/U-PROLOGUE) SWAP zx-<RESOLVE zx-RESOLVE> zx-CSP! ;

: BEGIN   zx-?COMP zx-CSP@ zx-<MARK ( fwd chain) 0 1 zx-!CSP ;
: WHILE   zsys: 0BRANCH (WHILE,) ;
: 0WHILE  zsys: TBRANCH (WHILE,) ;
: AGAIN   zsys: BRANCH (UNTIL,) ;
: REPEAT  [\\] AGAIN ;
: UNTIL   zsys: 0BRANCH (UNTIL,) ;
: 0UNTIL  zsys: TBRANCH (UNTIL,) ;


: IF     zx-?COMP zsys-run: 0BRANCH zx-MARK> 4 ;
: 0IF    zx-?COMP zsys-run: TBRANCH zx-MARK> 4 ;
: ENDIF  4 5 zx-?2PAIRS zx-RESOLVE> ;
: ELSE   4 zx-?CPAIRS zsys-run: BRANCH zx-MARK> SWAP zx-RESOLVE> 5 ;


|: (LOOP,)  ( brn-compile-cfa ) SWAP 3 zx-?CPAIRS execute SWAP zx-<RESOLVE zx-RESOLVE> zx-CSP! ;

: DO     zx-?COMP zsys-run: (DO) zx-CSP@ zx-<MARK ( fwd chain) 0 3 zx-!CSP ;
: FOR    zx-?COMP zsys-run: (FOR) zx-CSP@ zx-MARK> zx-<MARK SWAP 3 zx-!CSP ;
: LOOP   zsys: (LOOP) (LOOP,) ;
: +LOOP  zsys: (+LOOP) (LOOP,) ;


: BREAK
  zx-?COMP zx-CSP@ @ DUP 1 4 WITHIN 0= ?error" break of what?"
  3 - not?< zsys-run: RDROP zsys-run: RDROP >?  ;; clear stack for loops
  zx-CSP@ 4 + ( chain> addr )
  DUP @ zsys-run: BRANCH zx-CHAIN> SWAP ! ;

: CONTINUE
  zx-?COMP zx-CSP@ @ 1 3 WITHIN 0= ?error" continue what?"
  zx-CSP@ 8 + @ zsys-run: BRANCH zx-<RESOLVE ;


: CASE     zx-?COMP zx-CSP@ ( exit fwd chain) 0 6 zx-!CSP ;
\ : OF       6 zx-?CPAIRS zsys-run: OVER zsys-run: - zsys-run: TBRANCH zx-MARK> zsys-run: DROP 7 ;
: OF       6 zx-?CPAIRS zsys-run: (of<>) zsys-run: TBRANCH zx-MARK> zsys-run: DROP 7 ;
: ENDOF    7 zx-?CPAIRS zsys-run: BRANCH SWAP zx-CHAIN> SWAP zx-RESOLVE> 6 ;
: ENDCASE  DUP 6 8 zx-?2PAIRS 8 - ?< zsys-run: DROP >? zx-RESOLVE> zx-CSP! ;

: OTHERWISE  6 zx-?CPAIRS 8 ;


end-module \ SHADOW-HELPERS

end-module \ TCOM
